=== modified file 'INSTALL'
--- INSTALL	2008-10-28 18:00:20 +0000
+++ INSTALL	2008-10-05 17:38:31 +0000
@@ -127,6 +127,6 @@
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used, it is suggested that a more cryptographically
+  Is IPsec is not used, it is suggested that a more cryptographically
   secure checker program is used and configured, since without IPsec
   ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2009-01-15 04:55:10 +0000
+++ Makefile	2008-10-07 21:31:09 +0000
@@ -9,14 +9,13 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
-LINK_FORTIFY_LD=-z relro -fPIE
-LINK_FORTIFY=-pie
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIE -pie
+LINK_FORTIFY=-z relro -pie
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.4
+version=1.0.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -46,7 +45,7 @@
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=$(COVERAGE) $(LINK_FORTIFY)
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
@@ -71,13 +70,12 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
 	$<; $(HTMLPOST) $@
 # Fix citerefentry links
-HTMLPOST=$(SED) --in-place \
-	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
+HTMLPOST=$(SED) --in-place --expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
 
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
 CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen mandos-ctl $(CPROGS)
+PROGS=mandos mandos-keygen $(CPROGS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
@@ -88,7 +86,7 @@
 
 objects=$(addsuffix .o,$(CPROGS))
 
-all: $(PROGS) mandos.lsm
+all: $(PROGS)
 
 doc: $(DOCS)
 
@@ -150,35 +148,13 @@
 
 # Update all these files with version number $(version)
 common.ent: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(<ENTITY VERSION "\)[^"]*">$$/\1$(version)"/' \
-		$@
+	$(SED) --in-place --expression='s/^\(<ENTITY VERSION "\)[^"]*">$$/\1$(version)"/' $@
 
 mandos: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
+	$(SED) --in-place --expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' $@
 
 mandos-keygen: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos-ctl: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos.lsm: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@
-	$(SED) --in-place \
-		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@
-	$(SED) --in-place \
-		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
-		$@
+	$(SED) --in-place --expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' $@
 
 plugins.d/mandos-client: plugins.d/mandos-client.o
 	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
@@ -203,8 +179,7 @@
 run-client: all keydir/seckey.txt keydir/pubkey.txt
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
-		$(CLIENTARGS)
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt
 
 # Used by run-client
 keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
@@ -213,7 +188,7 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --configdir=confdir $(SERVERARGS)
+	./mandos --debug --configdir=confdir
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -227,7 +202,7 @@
 
 install: install-server install-client-nokey
 
-install-html: html
+install-html: $(htmldocs)
 	install --directory $(htmldir)
 	install --mode=u=rw,go=r --target-directory=$(htmldir) \
 		$(htmldocs)

=== modified file 'NEWS'
--- NEWS	2009-01-15 04:55:10 +0000
+++ NEWS	2008-10-07 21:31:09 +0000
@@ -1,35 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.0.4 (2009-01-15)
-* Server
-** Only find matched user/group pairs when searching for suitable
-   nonprivileged user/group to switch to.
-
-* Client
-** New kernel parameter "mandos=off" makes client not run at boot.
-** Fix linking errors and compilation warnings on AMD64.
-** Parse numbers in command line options better.
-** The splashy and usplash plugins are more robust while traversing
-   /proc, and will not abort if a process suddenly disappears.
-
-Version 1.0.3 (2009-01-06)
-* Server
-** Now tries to change to user and group "_mandos" before falling back
-   to trying the old values "mandos", "nobody:nogroup", and "65534".
-** Now does not abort on startup even if no clients are defined in
-   clients.conf.
-
-* Client
-** Plugins named "*.dpkg-bak" are now ignored.
-** Hopefully fixed compilation failure on some architectures where the
-   C compiler does not recognize the "-z" option as a linker option.
-
-Version 1.0.2 (2008-10-17)
-* mandos-keygen now signs the encrypted key blobs.  This signature is
-  not currently verified by mandos-client, but this may change in the
-  future.
-
 Version 1.0.1 (2008-10-07)
 * Server
 ** Expand environment variables and ~user in clients.conf's "secfile"

=== modified file 'README'
--- README	2009-01-12 22:02:33 +0000
+++ README	2008-10-12 07:27:43 +0000
@@ -152,14 +152,16 @@
     cryptsetup, this plugin listens to the same FIFO as askpass would
     do.
   
+  (None of these take any options or reads any files.)
+  
   More plugins could easily be written and added by the system
   administrator; see the section called "WRITING PLUGINS" in
   plugin-runner(8mandos) to learn the plugin requirements.
 
 * Copyright
 
-    Copyright © 2008,2009 Teddy Hogeborn
-    Copyright © 2008,2009 Björn Påhlsson
+    Copyright © 2008 Teddy Hogeborn
+                2008 Björn Påhlsson
   
 ** License:
    

=== modified file 'TODO'
--- TODO	2009-01-12 22:02:33 +0000
+++ TODO	2008-10-05 17:38:31 +0000
@@ -3,12 +3,8 @@
 * mandos-client
 ** TODO [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
-   klogctl(6, NULL, 0); klogctl(7, NULL, 0);
 ** TODO [#C] IPv4 support
 
-* plugin-runner
-** TODO [#B] use scandir(3) instead of readdir(3)
-
 * mandos (server)
 ** TODO [#B] Log level				:bugs:
 ** TODO /etc/mandos/clients.d/*.conf
@@ -17,12 +13,6 @@
 ** TODO [#B] Run-time communication with server :bugs:
    Probably using D-Bus
    See also [[*Mandos-tools]]
-*** Client class
-*** Main server
-    + SetLogLevel
-      syslogger.setLevel(logging.WARNING)
-    + Quit
-    + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
 ** TODO Implement --foreground			:bugs:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
@@ -30,23 +20,14 @@
 ** TODO Date+time on console log messages	:bugs:
    Is this the default?
 ** TODO delete hook when clients fall out by timeout
-   This will not be strictly necessary when the D-Bus interface is
-   implemented.
-
-* mandos.xml
-** [[file:mandos.xml::XXX][Document D-Bus interface]]
-
-* Provide and install /etc/dbus-1/system.d/mandos.conf
-
-* mandos-list
-*** Handle "no D-Bus server" and/or "no Mandos server found" better
-*** [#B] --dump option
+
+* Mandos-tools/utilities
+  All of this probably using D-Bus
+** TODO List clients
 ** TODO Disable client
 ** TODO Enable client
 ** TODO Reset timer
 
-* Curses interface
-
 * mandos-keygen
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
@@ -55,14 +36,11 @@
 
 * [#A] Package
 ** /usr/share/initramfs-tools/hooks/mandos
-*** TODO [#C] Do not install in initrd.img if configured not to.
+*** TODO Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/conf.d/mandos"?  Definitely a debconf
     question.
-** TODO [#C] /etc/bash_completion.d/mandos
+** TODO /etc/bash_completion.d/mandos
    From XML sources directly?
-** TODO initramfs-tools-script						  :test:
-   Do not insert plugin-runner as keyscript if a kernel parameter
-   "mandos=off" is passed.
 
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2009-01-08 03:54:06 +0000
+++ clients.conf	2008-09-21 13:42:34 +0000
@@ -14,7 +14,7 @@
 ;interval = 5m
 
 # What command to run as "the checker".
-;checker = fping -q -- %%(host)s
+;checker = fping -q -- %(host)s
 
 
 ;####

=== modified file 'debian/changelog'
--- debian/changelog	2009-01-15 04:55:10 +0000
+++ debian/changelog	2008-10-07 21:31:09 +0000
@@ -1,43 +1,3 @@
-mandos (1.0.4-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/watch: New file.
-  * debian/mandos-client.README.Debian: Document new "mandos=off" kernel
-    parameter.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 15 Jan 2009 05:49:22 +0100
-
-mandos (1.0.3-2) unstable; urgency=low
-
-  * Removed some now-unused debconf files.
-  * Changed postinst scripts to not source debconf/confmodule.
-  * Removed po-debconf from build-depends.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 06 Jan 2009 21:28:20 +0100
-
-mandos (1.0.3-1) unstable; urgency=low
-
-  * New upstream release.
-  * Add -Xlinker to linker flags to fix FTBFS for some architectures.
-    Thanks to Thiemo Seufer <ths@networkno.de> for the report and
-    fix. (Closes:  #509398)
-  * Remove debconf use altogether, thereby stopping debconf abuse.  Thanks
-    to Christian Perrier <bubulle@debian.org>. (Closes:  #509653)
-  * Add NEWS file to /usr/share/doc directories.
-  * Use and create "_mandos" user+group.  Rename old user+group created by
-    older versions of this package.
-  * Fix manual pages by adding build-depend on "docbook-xml".
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 06 Jan 2009 01:21:20 +0100
-
-mandos (1.0.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright: Rewritten to conform to
-    <http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233>.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Fri, 17 Oct 2008 20:42:12 +0200
-
 mandos (1.0.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2009-01-06 20:39:35 +0000
+++ debian/control	2008-09-30 03:19:39 +0000
@@ -4,8 +4,8 @@
 Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
 Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
 	   Björn Påhlsson <belorn@fukt.bsnet.se>
-Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
+Build-Depends: debhelper (>= 7), docbook-xsl, libavahi-core-dev,
+	libgpgme11-dev, libgnutls-dev, xsltproc, po-debconf,
 	pkg-config
 Standards-Version: 3.8.0
 Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk

=== modified file 'debian/copyright'
--- debian/copyright	2009-01-04 21:54:55 +0000
+++ debian/copyright	2008-10-15 19:54:11 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008,2009 Teddy Hogeborn
-Copyright: Copyright © 2008,2009 Björn Påhlsson
+Copyright: Copyright © 2008 Teddy Hogeborn
+Copyright: Copyright © 2008 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2009-01-15 02:52:02 +0000
+++ debian/mandos-client.README.Debian	2008-10-05 17:38:31 +0000
@@ -42,10 +42,4 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 12 Jan 2009 02:29:10 +0100
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  5 Oct 2008 19:04:26 +0200

=== added file 'debian/mandos-client.config'
--- debian/mandos-client.config	1970-01-01 00:00:00 +0000
+++ debian/mandos-client.config	2008-09-21 04:22:50 +0000
@@ -0,0 +1,27 @@
+#! /bin/sh
+#
+# config	Mandos Debconf configuration.
+#
+
+# Source debconf library.
+. /usr/share/debconf/confmodule
+if ! db_version 2.0; then
+    echo "mandos.config: need DebConf 2.0 or later"
+    exit 1
+fi
+
+set -e
+umask 022
+
+# Now, interaction.  Batch it in case any front ends can use this.
+db_beginblock
+
+# If this is a first time install then prompt 
+if [ "$1" = "configure" -a "$2" != "" ]; then
+	db_input high mandos-client/not-yet-configured || true
+fi
+
+db_endblock
+db_go || true
+
+exit 0

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos-client.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-01-06 05:08:37 +0000
+++ debian/mandos-client.postinst	2008-09-26 04:54:35 +0000
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+. /usr/share/debconf/confmodule
+
 # Update the initial RAM file system image
 update_initramfs()
 {
@@ -25,19 +27,10 @@
 
 # Add user and group
 add_mandos_user(){
-    # Rename old "mandos" user and group
-    case "$(getent passwd mandos)" in
-	*:Mandos\ password\ system,,,:/nonexistent:/bin/false)
-	    usermod --login _mandos mandos
-	    groupmod --new-name _mandos mandos
-	    return
-	    ;;
-    esac
-    # Create new user and group
-    if ! getent passwd _mandos >/dev/null; then
-	adduser --system --force-badname --quiet --home /nonexistent \
-	    --no-create-home --group --disabled-password \
-	    --gecos "Mandos password system" _mandos
+    if ! getent passwd mandos >/dev/null; then
+	adduser --disabled-password  --quiet --system \
+	    --home /nonexistent --no-create-home \
+	    --gecos "Mandos password system" --group mandos
     fi
 }
 

=== added file 'debian/mandos-client.templates'
--- debian/mandos-client.templates	1970-01-01 00:00:00 +0000
+++ debian/mandos-client.templates	2008-09-21 04:22:50 +0000
@@ -0,0 +1,8 @@
+Template: mandos-client/not-yet-configured
+Type: note
+_Description: Your system needs more configuration[ mandos-client]
+ Your system can not function as a Mandos client until a
+ password for this client has been added to the
+ configuration on the Mandos server.  Please read
+ /usr/share/doc/mandos-client/README.Debian.gz to find out
+ how.

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2009-01-04 22:15:01 +0000
+++ debian/mandos.README.Debian	2008-09-21 04:22:50 +0000
@@ -1,7 +1,7 @@
-The Mandos server is useless without at least one configured client in
+The Mandos server cannot run without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
 package on a client computer, and run "mandos-keygen --password" there
 to get a config file stanza.  Append that to /etc/mandos/clients.conf
 on the Mandos server.
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  4 Jan 2009 22:59:22 +0100
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sat, 20 Sep 2008 21:21:19 +0200

=== added file 'debian/mandos.config'
--- debian/mandos.config	1970-01-01 00:00:00 +0000
+++ debian/mandos.config	2008-09-21 04:22:50 +0000
@@ -0,0 +1,27 @@
+#! /bin/sh
+#
+# config	Mandos Debconf configuration.
+#
+
+# Source debconf library.
+. /usr/share/debconf/confmodule
+if ! db_version 2.0; then
+    echo "mandos.config: need DebConf 2.0 or later"
+    exit 1
+fi
+
+set -e
+umask 022
+
+# Now, interaction.  Batch it in case any front ends can use this.
+db_beginblock
+
+# If this is a first time install then prompt 
+if [ "$1" = "configure" -a "$2" != "" ]; then
+	db_input high mandos/not-yet-configured || true
+fi
+
+db_endblock
+db_go || true
+
+exit 0

=== modified file 'debian/mandos.docs'
--- debian/mandos.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-01-06 05:08:37 +0000
+++ debian/mandos.postinst	2008-09-26 04:54:35 +0000
@@ -15,21 +15,14 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+. /usr/share/debconf/confmodule
+
 case "$1" in
     configure)
-	# Rename old "mandos" user and group
-	case "$(getent passwd mandos)" in
-	    *:Mandos\ password\ system,,,:/nonexistent:/bin/false)
-		usermod --login _mandos mandos
-		groupmod --new-name _mandos mandos
-		;;
-	esac
-	# Create new user and group
-	if ! getent passwd _mandos >/dev/null; then
-	    adduser --system --force-badname --quiet \
-		--home /nonexistent --no-create-home --group \
-		--disabled-password --gecos "Mandos password system" \
-		_mandos
+	if ! getent passwd mandos >/dev/null; then
+	    adduser --disabled-password  --quiet --system \
+		--home /nonexistent --no-create-home \
+		--gecos "Mandos password system" --group mandos
 	fi
 	;;
 

=== added file 'debian/mandos.templates'
--- debian/mandos.templates	1970-01-01 00:00:00 +0000
+++ debian/mandos.templates	2008-09-21 04:22:50 +0000
@@ -0,0 +1,9 @@
+Template: mandos/not-yet-configured
+Type: note
+_Description: Your system needs more configuration[ mandos]
+ Your system has not yet been completely configured as a
+ Mandos server - clients need to be added to to
+ /etc/mandos/clients.conf.  Please read
+ /usr/share/doc/mandos/README.Debian.gz to find out how.
+ .
+ (The server has not been started.)

=== added file 'debian/po/POTFILES.in'
--- debian/po/POTFILES.in	1970-01-01 00:00:00 +0000
+++ debian/po/POTFILES.in	2008-09-21 04:22:50 +0000
@@ -0,0 +1,2 @@
+[type: gettext/rfc822deb] mandos.templates
+[type: gettext/rfc822deb] mandos-client.templates

=== added file 'debian/po/sv.po'
--- debian/po/sv.po	1970-01-01 00:00:00 +0000
+++ debian/po/sv.po	2008-09-21 04:22:50 +0000
@@ -0,0 +1,66 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the mandos package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: 1.0\n"
+"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
+"POT-Creation-Date: 2008-09-20 23:01+0200\n"
+"PO-Revision-Date: 2008-09-21 06:01+0200\n"
+"Last-Translator: Teddy Hogeborn <teddy@fukt.bsnet.se>\n"
+"Language-Team: Swedish <tp-sv@listor.tp-sv.se>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "Your system needs more configuration[ mandos]"
+msgstr "Ditt system behöver ytterligare konfigurering"
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+#| msgid ""
+#| "Your system has not yet been completely configured as a Mandos server - "
+#| "you need to setup /etc/mandos/clients.conf. Please read /usr/share/doc/"
+#| "mandos/README.Debian.gz to find out how."
+msgid ""
+"Your system has not yet been completely configured as a Mandos server - "
+"clients need to be added to to /etc/mandos/clients.conf.  Please read /usr/"
+"share/doc/mandos/README.Debian.gz to find out how."
+msgstr ""
+"Ditt system är inte helt inställd som en Mandos-server än -\n"
+"det behövs läggas till klienter i Mandos-serverns\n"
+"inställingar.  Var vänlig läs\n"
+"/usr/share/doc/mandos-client/README.Debian.gz för att få\n"
+"veta hur."
+
+#. Type: note
+#. Description
+#: ../mandos.templates:1001
+msgid "(The server has not been started.)"
+msgstr "(Servern har inte startats.)"
+
+#. Type: note
+#. Description
+#: ../mandos-client.templates:1001
+msgid "Your system needs more configuration[ mandos-client]"
+msgstr "Ditt system behöver ytterligare konfigurering"
+
+#. Type: note
+#. Description
+#: ../mandos-client.templates:1001
+msgid ""
+"Your system can not function as a Mandos client until a password for this "
+"client has been added to the configuration on the Mandos server.  Please "
+"read /usr/share/doc/mandos-client/README.Debian.gz to find out how."
+msgstr ""
+"Ditt system kan inte fungera som en Mandos-klient förrän\n"
+"ett krypterat lösenord har lagts till i Mandos-serverns\n"
+"inställingar.  Var vänlig läs\n"
+"/usr/share/doc/mandos-client/README.Debian.gz för att få\n"
+"veta hur."

=== modified file 'debian/rules'
--- debian/rules	2009-01-04 22:26:07 +0000
+++ debian/rules	2008-09-30 18:59:44 +0000
@@ -38,6 +38,7 @@
 	rm -f build-arch-stamp build-indep-stamp configure-stamp
 	dh_auto_clean
 	dh_clean
+	debconf-updatepo
 
 install: install-indep install-arch
 install-indep:
@@ -65,6 +66,7 @@
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
+	dh_installdebconf
 	dh_link
 	dh_strip
 	dh_compress

=== removed file 'debian/watch'
--- debian/watch	2009-01-15 02:52:02 +0000
+++ debian/watch	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-version=3
-ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z)

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2008-12-10 01:26:02 +0000
+++ initramfs-tools-hook	2008-09-19 00:54:24 +0000
@@ -51,13 +51,11 @@
     exit 1
 fi
 
-mandos_user="`{ getent passwd _mandos \
-		|| getent passwd mandos \
+mandos_user="`{ getent passwd mandos \
 		|| getent passwd nobody \
 		|| echo ::65534::::; } \
 	| awk --field-separator=: '{ print $3 }'`" 
-mandos_group="`{ getent group _mandos \
-		|| getent group mandos \
+mandos_group="`{ getent group mandos \
 		|| getent group nogroup \
 		|| echo ::65534:; } \
 	| awk --field-separator=: '{ print $3 }'`"
@@ -91,7 +89,7 @@
 	continue
     fi
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac
@@ -101,7 +99,7 @@
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-01-15 02:52:02 +0000
+++ initramfs-tools-script	2008-09-07 15:42:11 +0000
@@ -24,12 +24,6 @@
      ;;
 esac
 
-for param in `cat /proc/cmdline`; do
-    case "$param" in
-	mandos=off) exit 0;;
-    esac
-done
-
 chmod a=rwxt /tmp
 
 test -w /conf/conf.d/cryptroot

=== modified file 'mandos'
--- mandos	2009-01-15 04:55:10 +0000
+++ mandos	2008-10-07 21:31:09 +0000
@@ -11,8 +11,7 @@
 # and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008,2009 Teddy Hogeborn
-# Copyright © 2008,2009 Björn Påhlsson
+# Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,11 +30,11 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, with_statement, absolute_import
+from __future__ import division
 
 import SocketServer
 import socket
-import optparse
+from optparse import OptionParser
 import datetime
 import errno
 import gnutls.crypto
@@ -56,24 +55,22 @@
 import logging
 import logging.handlers
 import pwd
-from contextlib import closing
 
 import dbus
-import dbus.service
 import gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
 
-version = "1.0.4"
+version = "1.0.1"
 
 logger = logging.Logger('mandos')
-syslogger = (logging.handlers.SysLogHandler
-             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
-syslogger.setFormatter(logging.Formatter
-                       ('Mandos: %(levelname)s: %(message)s'))
+syslogger = logging.handlers.SysLogHandler\
+            (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+             address = "/dev/log")
+syslogger.setFormatter(logging.Formatter\
+                        ('Mandos: %(levelname)s: %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
@@ -82,11 +79,11 @@
 logger.addHandler(console)
 
 class AvahiError(Exception):
-    def __init__(self, value, *args, **kwargs):
+    def __init__(self, value):
         self.value = value
-        super(AvahiError, self).__init__(value, *args, **kwargs)
-    def __unicode__(self):
-        return unicode(repr(self.value))
+        super(AvahiError, self).__init__()
+    def __str__(self):
+        return repr(self.value)
 
 class AvahiServiceError(AvahiError):
     pass
@@ -112,13 +109,16 @@
                   a sensible number of times
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768):
+                 servicetype = None, port = None, TXT = None, domain = "",
+                 host = "", max_renames = 32768):
         self.interface = interface
         self.name = name
         self.type = servicetype
         self.port = port
-        self.TXT = TXT if TXT is not None else []
+        if TXT is None:
+            self.TXT = []
+        else:
+            self.TXT = TXT
         self.domain = domain
         self.host = host
         self.rename_count = 0
@@ -129,13 +129,13 @@
             logger.critical(u"No suitable Zeroconf service name found"
                             u" after %i retries, exiting.",
                             self.rename_count)
-            raise AvahiServiceError(u"Too many renames")
+            raise AvahiServiceError("Too many renames")
         self.name = server.GetAlternativeServiceName(self.name)
         logger.info(u"Changing Zeroconf service name to %r ...",
                     str(self.name))
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
-                                ' %%(message)s' % self.name))
+                               ' %%(message)s' % self.name))
         self.remove()
         self.add()
         self.rename_count += 1
@@ -147,10 +147,10 @@
         """Derived from the Avahi example code"""
         global group
         if group is None:
-            group = dbus.Interface(bus.get_object
-                                   (avahi.DBUS_NAME,
+            group = dbus.Interface\
+                    (bus.get_object(avahi.DBUS_NAME,
                                     server.EntryGroupNew()),
-                                   avahi.DBUS_INTERFACE_ENTRY_GROUP)
+                     avahi.DBUS_INTERFACE_ENTRY_GROUP)
             group.connect_to_signal('StateChanged',
                                     entry_group_state_changed)
         logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
@@ -170,199 +170,151 @@
 # End of Avahi example code
 
 
-def _datetime_to_dbus(dt, variant_level=0):
-    """Convert a UTC datetime.datetime() to a D-Bus type."""
-    return dbus.String(dt.isoformat(), variant_level=variant_level)
-
-
-class Client(dbus.service.Object):
+class Client(object):
     """A representation of a client host served by this server.
     Attributes:
-    name:       string; from the config file, used in log messages
+    name:      string; from the config file, used in log messages
     fingerprint: string (40 or 32 hexadecimal digits); used to
                  uniquely identify the client
-    secret:     bytestring; sent verbatim (over TLS) to client
-    host:       string; available for use by the checker command
-    created:    datetime.datetime(); (UTC) object creation
-    last_enabled: datetime.datetime(); (UTC)
-    enabled:    bool()
-    last_checked_ok: datetime.datetime(); (UTC) or None
-    timeout:    datetime.timedelta(); How long from last_checked_ok
-                                      until this client is invalid
-    interval:   datetime.timedelta(); How often to start a new checker
-    disable_hook:  If set, called by disable() as disable_hook(self)
-    checker:    subprocess.Popen(); a running checker process used
-                                    to see if the client lives.
-                                    'None' if no process is running.
+    secret:    bytestring; sent verbatim (over TLS) to client
+    host:      string; available for use by the checker command
+    created:   datetime.datetime(); object creation, not client host
+    last_checked_ok: datetime.datetime() or None if not yet checked OK
+    timeout:   datetime.timedelta(); How long from last_checked_ok
+                                     until this client is invalid
+    interval:  datetime.timedelta(); How often to start a new checker
+    stop_hook: If set, called by stop() as stop_hook(self)
+    checker:   subprocess.Popen(); a running checker process used
+                                   to see if the client lives.
+                                   'None' if no process is running.
     checker_initiator_tag: a gobject event source tag, or None
-    disable_initiator_tag:    - '' -
+    stop_initiator_tag:    - '' -
     checker_callback_tag:  - '' -
     checker_command: string; External command which is run to check if
                      client lives.  %() expansions are done at
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
-    use_dbus: bool(); Whether to provide D-Bus interface and signals
-    dbus_object_path: dbus.ObjectPath ; only set if self.use_dbus
+    Private attibutes:
+    _timeout: Real variable for 'timeout'
+    _interval: Real variable for 'interval'
+    _timeout_milliseconds: Used when calling gobject.timeout_add()
+    _interval_milliseconds: - '' -
     """
-    def timeout_milliseconds(self):
-        "Return the 'timeout' attribute in milliseconds"
-        return ((self.timeout.days * 24 * 60 * 60 * 1000)
-                + (self.timeout.seconds * 1000)
-                + (self.timeout.microseconds // 1000))
-    
-    def interval_milliseconds(self):
-        "Return the 'interval' attribute in milliseconds"
-        return ((self.interval.days * 24 * 60 * 60 * 1000)
-                + (self.interval.seconds * 1000)
-                + (self.interval.microseconds // 1000))
-    
-    def __init__(self, name = None, disable_hook=None, config=None,
-                 use_dbus=True):
+    def _set_timeout(self, timeout):
+        "Setter function for 'timeout' attribute"
+        self._timeout = timeout
+        self._timeout_milliseconds = ((self.timeout.days
+                                       * 24 * 60 * 60 * 1000)
+                                      + (self.timeout.seconds * 1000)
+                                      + (self.timeout.microseconds
+                                         // 1000))
+    timeout = property(lambda self: self._timeout,
+                       _set_timeout)
+    del _set_timeout
+    def _set_interval(self, interval):
+        "Setter function for 'interval' attribute"
+        self._interval = interval
+        self._interval_milliseconds = ((self.interval.days
+                                        * 24 * 60 * 60 * 1000)
+                                       + (self.interval.seconds
+                                          * 1000)
+                                       + (self.interval.microseconds
+                                          // 1000))
+    interval = property(lambda self: self._interval,
+                        _set_interval)
+    del _set_interval
+    def __init__(self, name = None, stop_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
-        self.name = name
         if config is None:
             config = {}
+        self.name = name
         logger.debug(u"Creating client %r", self.name)
-        self.use_dbus = use_dbus
-        if self.use_dbus:
-            self.dbus_object_path = (dbus.ObjectPath
-                                     ("/Mandos/clients/"
-                                      + self.name.replace(".", "_")))
-            dbus.service.Object.__init__(self, bus,
-                                         self.dbus_object_path)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
-        self.fingerprint = (config["fingerprint"].upper()
-                            .replace(u" ", u""))
+        self.fingerprint = config["fingerprint"].upper()\
+                           .replace(u" ", u"")
         logger.debug(u"  Fingerprint: %s", self.fingerprint)
         if "secret" in config:
             self.secret = config["secret"].decode(u"base64")
         elif "secfile" in config:
-            with closing(open(os.path.expanduser
-                              (os.path.expandvars
-                               (config["secfile"])))) as secfile:
-                self.secret = secfile.read()
+            secfile = open(os.path.expanduser(os.path.expandvars
+                                              (config["secfile"])))
+            self.secret = secfile.read()
+            secfile.close()
         else:
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get("host", "")
-        self.created = datetime.datetime.utcnow()
-        self.enabled = False
-        self.last_enabled = None
+        self.created = datetime.datetime.now()
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
         self.interval = string_to_delta(config["interval"])
-        self.disable_hook = disable_hook
+        self.stop_hook = stop_hook
         self.checker = None
         self.checker_initiator_tag = None
-        self.disable_initiator_tag = None
+        self.stop_initiator_tag = None
         self.checker_callback_tag = None
-        self.checker_command = config["checker"]
-    
-    def enable(self):
+        self.check_command = config["checker"]
+    def start(self):
         """Start this client's checker and timeout hooks"""
-        self.last_enabled = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
+        self.checker_initiator_tag = gobject.timeout_add\
+                                     (self._interval_milliseconds,
+                                      self.start_checker)
         # Also start a new checker *right now*.
         self.start_checker()
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        self.enabled = True
-        if self.use_dbus:
-            # Emit D-Bus signals
-            self.PropertyChanged(dbus.String(u"enabled"),
-                                 dbus.Boolean(True, variant_level=1))
-            self.PropertyChanged(dbus.String(u"last_enabled"),
-                                 (_datetime_to_dbus(self.last_enabled,
-                                                    variant_level=1)))
-    
-    def disable(self):
-        """Disable this client."""
-        if not getattr(self, "enabled", False):
+        # Schedule a stop() when 'timeout' has passed
+        self.stop_initiator_tag = gobject.timeout_add\
+                                  (self._timeout_milliseconds,
+                                   self.stop)
+    def stop(self):
+        """Stop this client.
+        The possibility that a client might be restarted is left open,
+        but not currently used."""
+        # If this client doesn't have a secret, it is already stopped.
+        if hasattr(self, "secret") and self.secret:
+            logger.info(u"Stopping client %s", self.name)
+            self.secret = None
+        else:
             return False
-        logger.info(u"Disabling client %s", self.name)
-        if getattr(self, "disable_initiator_tag", False):
-            gobject.source_remove(self.disable_initiator_tag)
-            self.disable_initiator_tag = None
+        if getattr(self, "stop_initiator_tag", False):
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = None
         if getattr(self, "checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
-        if self.disable_hook:
-            self.disable_hook(self)
-        self.enabled = False
-        if self.use_dbus:
-            # Emit D-Bus signal
-            self.PropertyChanged(dbus.String(u"enabled"),
-                                 dbus.Boolean(False, variant_level=1))
+        if self.stop_hook:
+            self.stop_hook(self)
         # Do not run this again if called by a gobject.timeout_add
         return False
-    
     def __del__(self):
-        self.disable_hook = None
-        self.disable()
-    
-    def checker_callback(self, pid, condition, command):
+        self.stop_hook = None
+        self.stop()
+    def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
+        now = datetime.datetime.now()
         self.checker_callback_tag = None
         self.checker = None
-        if self.use_dbus:
-            # Emit D-Bus signal
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
-        if (os.WIFEXITED(condition)
-            and (os.WEXITSTATUS(condition) == 0)):
+        if os.WIFEXITED(condition) \
+               and (os.WEXITSTATUS(condition) == 0):
             logger.info(u"Checker for %(name)s succeeded",
                         vars(self))
-            if self.use_dbus:
-                # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(True),
-                                      dbus.UInt16(condition),
-                                      dbus.String(command))
-            self.bump_timeout()
+            self.last_checked_ok = now
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = gobject.timeout_add\
+                                      (self._timeout_milliseconds,
+                                       self.stop)
         elif not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
-            if self.use_dbus:
-                # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(False),
-                                      dbus.UInt16(condition),
-                                      dbus.String(command))
         else:
             logger.info(u"Checker for %(name)s failed",
                         vars(self))
-            if self.use_dbus:
-                # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(False),
-                                      dbus.UInt16(condition),
-                                      dbus.String(command))
-    
-    def bump_timeout(self):
-        """Bump up the timeout for this client.
-        This should only be called when the client has been seen,
-        alive and well.
-        """
-        self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (self.timeout_milliseconds(),
-                                       self.disable))
-        if self.use_dbus:
-            # Emit D-Bus signal
-            self.PropertyChanged(
-                dbus.String(u"last_checked_ok"),
-                (_datetime_to_dbus(self.last_checked_ok,
-                                   variant_level=1)))
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
@@ -377,18 +329,18 @@
         # is as it should be.
         if self.checker is None:
             try:
-                # In case checker_command has exactly one % operator
-                command = self.checker_command % self.host
+                # In case check_command has exactly one % operator
+                command = self.check_command % self.host
             except TypeError:
                 # Escape attributes for the shell
                 escaped_attrs = dict((key, re.escape(str(val)))
                                      for key, val in
                                      vars(self).iteritems())
                 try:
-                    command = self.checker_command % escaped_attrs
+                    command = self.check_command % escaped_attrs
                 except TypeError, error:
                     logger.error(u'Could not format string "%s":'
-                                 u' %s', self.checker_command, error)
+                                 u' %s', self.check_command, error)
                     return True # Try again later
             try:
                 logger.info(u"Starting checker %r for %s",
@@ -400,22 +352,14 @@
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
                                                 shell=True, cwd="/")
-                if self.use_dbus:
-                    # Emit D-Bus signal
-                    self.CheckerStarted(command)
-                    self.PropertyChanged(
-                        dbus.String("checker_running"),
-                        dbus.Boolean(True, variant_level=1))
-                self.checker_callback_tag = (gobject.child_watch_add
-                                             (self.checker.pid,
-                                              self.checker_callback,
-                                              data=command))
+                self.checker_callback_tag = gobject.child_watch_add\
+                                            (self.checker.pid,
+                                             self.checker_callback)
             except OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
-    
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
         if self.checker_callback_tag:
@@ -433,168 +377,26 @@
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
-        if self.use_dbus:
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
-    
     def still_valid(self):
         """Has the timeout not yet passed for this client?"""
-        if not getattr(self, "enabled", False):
-            return False
-        now = datetime.datetime.utcnow()
+        now = datetime.datetime.now()
         if self.last_checked_ok is None:
             return now < (self.created + self.timeout)
         else:
             return now < (self.last_checked_ok + self.timeout)
-    
-    ## D-Bus methods & signals
-    _interface = u"org.mandos_system.Mandos.Client"
-    
-    # BumpTimeout - method
-    BumpTimeout = dbus.service.method(_interface)(bump_timeout)
-    BumpTimeout.__name__ = "BumpTimeout"
-    
-    # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="bqs")
-    def CheckerCompleted(self, success, condition, command):
-        "D-Bus signal"
-        pass
-    
-    # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature="s")
-    def CheckerStarted(self, command):
-        "D-Bus signal"
-        pass
-    
-    # GetAllProperties - method
-    @dbus.service.method(_interface, out_signature="a{sv}")
-    def GetAllProperties(self):
-        "D-Bus method"
-        return dbus.Dictionary({
-                dbus.String("name"):
-                    dbus.String(self.name, variant_level=1),
-                dbus.String("fingerprint"):
-                    dbus.String(self.fingerprint, variant_level=1),
-                dbus.String("host"):
-                    dbus.String(self.host, variant_level=1),
-                dbus.String("created"):
-                    _datetime_to_dbus(self.created, variant_level=1),
-                dbus.String("last_enabled"):
-                    (_datetime_to_dbus(self.last_enabled,
-                                       variant_level=1)
-                     if self.last_enabled is not None
-                     else dbus.Boolean(False, variant_level=1)),
-                dbus.String("enabled"):
-                    dbus.Boolean(self.enabled, variant_level=1),
-                dbus.String("last_checked_ok"):
-                    (_datetime_to_dbus(self.last_checked_ok,
-                                       variant_level=1)
-                     if self.last_checked_ok is not None
-                     else dbus.Boolean (False, variant_level=1)),
-                dbus.String("timeout"):
-                    dbus.UInt64(self.timeout_milliseconds(),
-                                variant_level=1),
-                dbus.String("interval"):
-                    dbus.UInt64(self.interval_milliseconds(),
-                                variant_level=1),
-                dbus.String("checker"):
-                    dbus.String(self.checker_command,
-                                variant_level=1),
-                dbus.String("checker_running"):
-                    dbus.Boolean(self.checker is not None,
-                                 variant_level=1),
-                }, signature="sv")
-    
-    # IsStillValid - method
-    IsStillValid = (dbus.service.method(_interface, out_signature="b")
-                    (still_valid))
-    IsStillValid.__name__ = "IsStillValid"
-    
-    # PropertyChanged - signal
-    @dbus.service.signal(_interface, signature="sv")
-    def PropertyChanged(self, property, value):
-        "D-Bus signal"
-        pass
-    
-    # SetChecker - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetChecker(self, checker):
-        "D-Bus setter method"
-        self.checker_command = checker
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
-    
-    # SetHost - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetHost(self, host):
-        "D-Bus setter method"
-        self.host = host
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"host"),
-                             dbus.String(self.host, variant_level=1))
-    
-    # SetInterval - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetInterval(self, milliseconds):
-        self.interval = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"interval"),
-                             (dbus.UInt64(self.interval_milliseconds(),
-                                          variant_level=1)))
-    
-    # SetSecret - method
-    @dbus.service.method(_interface, in_signature="ay",
-                         byte_arrays=True)
-    def SetSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = str(secret)
-    
-    # SetTimeout - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetTimeout(self, milliseconds):
-        self.timeout = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"timeout"),
-                             (dbus.UInt64(self.timeout_milliseconds(),
-                                          variant_level=1)))
-    
-    # Enable - method
-    Enable = dbus.service.method(_interface)(enable)
-    Enable.__name__ = "Enable"
-    
-    # StartChecker - method
-    @dbus.service.method(_interface)
-    def StartChecker(self):
-        "D-Bus method"
-        self.start_checker()
-    
-    # Disable - method
-    @dbus.service.method(_interface)
-    def Disable(self):
-        "D-Bus method"
-        self.disable()
-    
-    # StopChecker - method
-    StopChecker = dbus.service.method(_interface)(stop_checker)
-    StopChecker.__name__ = "StopChecker"
-    
-    del _interface
 
 
 def peer_certificate(session):
     "Return the peer's OpenPGP certificate as a bytestring"
     # If not an OpenPGP certificate...
-    if (gnutls.library.functions
-        .gnutls_certificate_type_get(session._c_object)
-        != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
+    if gnutls.library.functions.gnutls_certificate_type_get\
+            (session._c_object) \
+           != gnutls.library.constants.GNUTLS_CRT_OPENPGP:
         # ...do the normal thing
         return session.peer_certificate
     list_size = ctypes.c_uint()
-    cert_list = (gnutls.library.functions
-                 .gnutls_certificate_get_peers
-                 (session._c_object, ctypes.byref(list_size)))
+    cert_list = gnutls.library.functions.gnutls_certificate_get_peers\
+        (session._c_object, ctypes.byref(list_size))
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -604,24 +406,22 @@
 def fingerprint(openpgp):
     "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
     # New GnuTLS "datum" with the OpenPGP public key
-    datum = (gnutls.library.types
-             .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                         ctypes.POINTER
-                                         (ctypes.c_ubyte)),
-                             ctypes.c_uint(len(openpgp))))
+    datum = gnutls.library.types.gnutls_datum_t\
+        (ctypes.cast(ctypes.c_char_p(openpgp),
+                     ctypes.POINTER(ctypes.c_ubyte)),
+         ctypes.c_uint(len(openpgp)))
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+    gnutls.library.functions.gnutls_openpgp_crt_init\
+        (ctypes.byref(crt))
     # Import the OpenPGP public key into the certificate
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                gnutls.library.constants
-                                .GNUTLS_OPENPGP_FMT_RAW))
+    gnutls.library.functions.gnutls_openpgp_crt_import\
+                    (crt, ctypes.byref(datum),
+                     gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
     # Verify the self signature in the key
     crtverify = ctypes.c_uint()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_verify_self(crt, 0, ctypes.byref(crtverify)))
+    gnutls.library.functions.gnutls_openpgp_crt_verify_self\
+        (crt, 0, ctypes.byref(crtverify))
     if crtverify.value != 0:
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         raise gnutls.errors.CertificateSecurityError("Verify failed")
@@ -629,9 +429,8 @@
     buf = ctypes.create_string_buffer(20)
     buf_len = ctypes.c_size_t()
     # Get the fingerprint from the certificate into the buffer
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                         ctypes.byref(buf_len)))
+    gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint\
+        (crt, ctypes.byref(buf), ctypes.byref(buf_len))
     # Deinit the certificate
     gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
     # Convert the buffer to a Python bytestring
@@ -648,11 +447,9 @@
     
     def handle(self):
         logger.info(u"TCP connection from: %s",
-                    unicode(self.client_address))
-        session = (gnutls.connection
-                   .ClientSession(self.request,
-                                  gnutls.connection
-                                  .X509Credentials()))
+                     unicode(self.client_address))
+        session = gnutls.connection.ClientSession\
+                  (self.request, gnutls.connection.X509Credentials())
         
         line = self.request.makefile().readline()
         logger.debug(u"Protocol version: %r", line)
@@ -671,11 +468,12 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        # Use a fallback default, since this MUST be set.
-        priority = self.server.settings.get("priority", "NORMAL")
-        (gnutls.library.functions
-         .gnutls_priority_set_direct(session._c_object,
-                                     priority, None))
+        priority = "NORMAL"             # Fallback default, since this
+                                        # MUST be set.
+        if self.server.settings["priority"]:
+            priority = self.server.settings["priority"]
+        gnutls.library.functions.gnutls_priority_set_direct\
+            (session._c_object, priority, None)
         
         try:
             session.handshake()
@@ -691,11 +489,12 @@
             session.bye()
             return
         logger.debug(u"Fingerprint: %s", fpr)
+        client = None
         for c in self.server.clients:
             if c.fingerprint == fpr:
                 client = c
                 break
-        else:
+        if not client:
             logger.warning(u"Client not found for fingerprint: %s",
                            fpr)
             session.bye()
@@ -708,8 +507,6 @@
                            vars(client))
             session.bye()
             return
-        ## This won't work here, since we're in a fork.
-        # client.bump_timeout()
         sent_size = 0
         while sent_size < len(client.secret):
             sent = session.send(client.secret[sent_size:])
@@ -720,8 +517,7 @@
         session.bye()
 
 
-class IPv6_TCPServer(SocketServer.ForkingMixIn,
-                     SocketServer.TCPServer, object):
+class IPv6_TCPServer(SocketServer.ForkingTCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
         settings:       Server settings
@@ -840,15 +636,14 @@
     elif state == avahi.ENTRY_GROUP_FAILURE:
         logger.critical(u"Avahi: Error in group state changed %s",
                         unicode(error))
-        raise AvahiGroupError(u"State changed: %s" % unicode(error))
+        raise AvahiGroupError("State changed: %s", str(error))
 
 def if_nametoindex(interface):
     """Call the C function if_nametoindex(), or equivalent"""
     global if_nametoindex
     try:
-        if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library("c"))
-                          .if_nametoindex)
+        if_nametoindex = ctypes.cdll.LoadLibrary\
+            (ctypes.util.find_library("c")).if_nametoindex
     except (OSError, AttributeError):
         if "struct" not in sys.modules:
             import struct
@@ -857,9 +652,10 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack("16s16x", interface))
+            s = socket.socket()
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack("16s16x", interface))
+            s.close()
             interface_index = struct.unpack("I", ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)
@@ -889,14 +685,14 @@
 
 
 def main():
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
+    parser = OptionParser(version = "%%prog %s" % version)
     parser.add_option("-i", "--interface", type="string",
                       metavar="IF", help="Bind to interface IF")
     parser.add_option("-a", "--address", type="string",
                       help="Address to listen for requests on")
     parser.add_option("-p", "--port", type="int",
                       help="Port number to receive requests on")
-    parser.add_option("--check", action="store_true",
+    parser.add_option("--check", action="store_true", default=False,
                       help="Run self-test")
     parser.add_option("--debug", action="store_true",
                       help="Debug mode; run in foreground and log to"
@@ -909,9 +705,6 @@
                       default="/etc/mandos", metavar="DIR",
                       help="Directory to search for configuration"
                       " files")
-    parser.add_option("--no-dbus", action="store_false",
-                      dest="use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
     options = parser.parse_args()[0]
     
     if options.check:
@@ -927,7 +720,6 @@
                         "priority":
                         "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
                         "servicename": "Mandos",
-                        "use_dbus": "True",
                         }
     
     # Parse config file for server-global settings
@@ -936,35 +728,29 @@
     server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
-    # Use getboolean on the boolean config options
-    server_settings["debug"] = (server_config.getboolean
-                                ("DEFAULT", "debug"))
-    server_settings["use_dbus"] = (server_config.getboolean
-                                   ("DEFAULT", "use_dbus"))
+    # Use getboolean on the boolean config option
+    server_settings["debug"] = server_config.getboolean\
+                               ("DEFAULT", "debug")
     del server_config
     
     # Override the settings from the config file with command line
     # options, if set.
     for option in ("interface", "address", "port", "debug",
-                   "priority", "servicename", "configdir",
-                   "use_dbus"):
+                   "priority", "servicename", "configdir"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
     del options
     # Now we have our good server settings in "server_settings"
     
-    # For convenience
     debug = server_settings["debug"]
-    use_dbus = server_settings["use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     
     if not debug:
         syslogger.setLevel(logging.WARNING)
         console.setLevel(logging.WARNING)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
                                 ' %%(message)s'
                                 % server_settings["servicename"]))
@@ -972,7 +758,7 @@
     # Parse config file with clients
     client_defaults = { "timeout": "1h",
                         "interval": "5m",
-                        "checker": "fping -q -- %%(host)s",
+                        "checker": "fping -q -- %(host)s",
                         "host": "",
                         }
     client_config = ConfigParser.SafeConfigParser(client_defaults)
@@ -991,20 +777,22 @@
     except IOError, error:
         logger.error("Could not open file %r", pidfilename)
     
-    try:
-        uid = pwd.getpwnam("_mandos").pw_uid
-        gid = pwd.getpwnam("_mandos").pw_gid
-    except KeyError:
-        try:
-            uid = pwd.getpwnam("mandos").pw_uid
-            gid = pwd.getpwnam("mandos").pw_gid
-        except KeyError:
-            try:
-                uid = pwd.getpwnam("nobody").pw_uid
-                gid = pwd.getpwnam("nogroup").pw_gid
-            except KeyError:
-                uid = 65534
-                gid = 65534
+    uid = 65534
+    gid = 65534
+    try:
+        uid = pwd.getpwnam("mandos").pw_uid
+    except KeyError:
+        try:
+            uid = pwd.getpwnam("nobody").pw_uid
+        except KeyError:
+            pass
+    try:
+        gid = pwd.getpwnam("mandos").pw_gid
+    except KeyError:
+        try:
+            gid = pwd.getpwnam("nogroup").pw_gid
+        except KeyError:
+            pass
     try:
         os.setuid(uid)
         os.setgid(gid)
@@ -1016,8 +804,8 @@
     service = AvahiService(name = server_settings["servicename"],
                            servicetype = "_mandos._tcp", )
     if server_settings["interface"]:
-        service.interface = (if_nametoindex
-                             (server_settings["interface"]))
+        service.interface = if_nametoindex\
+                            (server_settings["interface"])
     
     global main_loop
     global bus
@@ -1030,17 +818,21 @@
                                            avahi.DBUS_PATH_SERVER),
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
-    if use_dbus:
-        bus_name = dbus.service.BusName(u"org.mandos-system.Mandos",
-                                        bus)
+    
+    def remove_from_clients(client):
+        clients.remove(client)
+        if not clients:
+            logger.critical(u"No clients left, exiting")
+            sys.exit()
     
     clients.update(Set(Client(name = section,
+                              stop_hook = remove_from_clients,
                               config
-                              = dict(client_config.items(section)),
-                              use_dbus = use_dbus)
+                              = dict(client_config.items(section)))
                        for section in client_config.sections()))
     if not clients:
-        logger.warning(u"No clients defined")
+        logger.critical(u"No clients defined")
+        sys.exit(1)
     
     if debug:
         # Redirect stdin so all checkers get /dev/null
@@ -1078,8 +870,8 @@
         
         while clients:
             client = clients.pop()
-            client.disable_hook = None
-            client.disable()
+            client.stop_hook = None
+            client.stop()
     
     atexit.register(cleanup)
     
@@ -1088,61 +880,8 @@
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
-    if use_dbus:
-        class MandosServer(dbus.service.Object):
-            """A D-Bus proxy object"""
-            def __init__(self):
-                dbus.service.Object.__init__(self, bus,
-                                             "/Mandos")
-            _interface = u"org.mandos_system.Mandos"
-
-            @dbus.service.signal(_interface, signature="oa{sv}")
-            def ClientAdded(self, objpath, properties):
-                "D-Bus signal"
-                pass
-
-            @dbus.service.signal(_interface, signature="o")
-            def ClientRemoved(self, objpath):
-                "D-Bus signal"
-                pass
-
-            @dbus.service.method(_interface, out_signature="ao")
-            def GetAllClients(self):
-                return dbus.Array(c.dbus_object_path for c in clients)
-
-            @dbus.service.method(_interface, out_signature="a{oa{sv}}")
-            def GetAllClientsWithProperties(self):
-                return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAllProperties())
-                     for c in clients),
-                    signature="oa{sv}")
-
-            @dbus.service.method(_interface, in_signature="o")
-            def RemoveClient(self, object_path):
-                for c in clients:
-                    if c.dbus_object_path == object_path:
-                        clients.remove(c)
-                        # Don't signal anything except ClientRemoved
-                        c.use_dbus = False
-                        c.disable()
-                        # Emit D-Bus signal
-                        self.ClientRemoved(object_path)
-                        return
-                raise KeyError
-            @dbus.service.method(_interface)
-            def Quit(self):
-                main_loop.quit()
-
-            del _interface
-    
-        mandos_server = MandosServer()
-    
     for client in clients:
-        if use_dbus:
-            # Emit D-Bus signal
-            mandos_server.ClientAdded(client.dbus_object_path,
-                                      client.GetAllProperties())
-        client.enable()
+        client.start()
     
     tcp_server.enable()
     tcp_server.server_activate()
@@ -1166,13 +905,13 @@
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:
-                             (tcp_server.handle_request
-                              (*args[2:], **kwargs) or True))
+                             tcp_server.handle_request\
+                             (*args[2:], **kwargs) or True)
         
         logger.debug(u"Starting main loop")
         main_loop.run()
     except AvahiError, error:
-        logger.critical(u"AvahiError: %s", error)
+        logger.critical(u"AvahiError: %s" + unicode(error))
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2009-01-08 03:54:06 +0000
+++ mandos-clients.conf.xml	2008-10-07 21:31:09 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2009-01-08">
+<!ENTITY TIMESTAMP "2008-10-07">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -170,7 +169,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.
+	    >--</option> %(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option
@@ -351,7 +350,7 @@
 [DEFAULT]
 timeout = 1h
 interval = 5m
-checker = fping -q -- %%(host)s
+checker = fping -q -- %(host)s
 
 # Client "foo"
 [foo]

=== removed file 'mandos-ctl'
--- mandos-ctl	2009-01-15 04:55:10 +0000
+++ mandos-ctl	1970-01-01 00:00:00 +0000
@@ -1,187 +0,0 @@
-#!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
-
-from __future__ import division
-import sys
-import dbus
-from optparse import OptionParser
-import locale
-import datetime
-import re
-
-locale.setlocale(locale.LC_ALL, u'')
-
-tablewords = {
-    'name': u'Name',
-    'enabled': u'Enabled',
-    'timeout': u'Timeout',
-    'last_checked_ok': u'Last Successful Check',
-    'created': u'Created',
-    'interval': u'Interval',
-    'host': u'Host',
-    'fingerprint': u'Fingerprint',
-    'checker_running': u'Check Is Running',
-    'last_enabled': u'Last Enabled',
-    'checker': u'Checker',
-    }
-defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
-                   'checker')
-busname = 'org.mandos-system.Mandos'
-server_path = '/Mandos'
-server_interface = 'org.mandos_system.Mandos'
-client_interface = 'org.mandos_system.Mandos.Client'
-version = "1.0.4"
-
-bus = dbus.SystemBus()
-mandos_dbus_objc = bus.get_object(busname, server_path)
-mandos_serv = dbus.Interface(mandos_dbus_objc,
-                             dbus_interface = server_interface)
-mandos_clients = mandos_serv.GetAllClientsWithProperties()
-
-def datetime_to_milliseconds(dt):
-    "Return the 'timeout' attribute in milliseconds"
-    return ((dt.days * 24 * 60 * 60 * 1000)
-            + (dt.seconds * 1000)
-            + (dt.microseconds // 1000))
-
-def milliseconds_to_string(ms):
-    td = datetime.timedelta(0, 0, 0, ms)
-    return "%s%02d:%02d:%02d" % (("%dT" % td.days) if td.days else "", # days
-                           td.seconds // 3600,        # hours
-                           (td.seconds % 3600) // 60, # minutes
-                           (td.seconds % 60))         # seconds
-
-
-def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
-    datetime.timedelta(7)
-    >>> string_to_delta('60s')
-    datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
-    datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
-    datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
-    datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
-    datetime.timedelta(0, 330)
-    """
-    timevalue = datetime.timedelta(0)
-    regexp = re.compile("\d+[dsmhw]")
-    
-    for s in regexp.findall(interval):
-        try:
-            suffix = unicode(s[-1])
-            value = int(s[:-1])
-            if suffix == u"d":
-                delta = datetime.timedelta(value)
-            elif suffix == u"s":
-                delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
-                delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
-            else:
-                raise ValueError
-        except (ValueError, IndexError):
-            raise ValueError
-        timevalue += delta
-    return timevalue
-
-def print_clients(clients):
-    def valuetostring(value, keyword):
-        if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in ("timeout", "interval"):
-            return milliseconds_to_string(value)
-        return unicode(value)
-    
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key], key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
-    print format_string % tuple(tablewords[key] for key in keywords) 
-    for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
-
-parser = OptionParser(version = "%%prog %s" % version)
-parser.add_option("-a", "--all", action="store_true",
-                  help="Print all fields")
-parser.add_option("-e", "--enable", action="store_true",
-                  help="Enable specified client")
-parser.add_option("-d", "--disable", action="store_true",
-                  help="disable specified client")
-parser.add_option("-b", "--bump-timeout", action="store_true",
-                  help="Bump timeout of specified client")
-parser.add_option("--start-checker", action="store_true",
-                  help="Start checker for specified client")
-parser.add_option("--stop-checker", action="store_true",
-                  help="Stop checker for specified client")
-parser.add_option("-v", "--is-valid", action="store_true",
-                  help="Stop checker for specified client")
-parser.add_option("-c", "--checker", type="string",
-                  help="Set checker command for specified client")
-parser.add_option("-t", "--timeout", type="string",
-                  help="Set timeout for specified client")
-parser.add_option("-i", "--interval", type="string",
-                  help="Set checker interval for specified client")
-parser.add_option("-H", "--host", type="string",
-                  help="Set host for specified client")
-parser.add_option("-s", "--secret", type="string",
-                  help="Set password blob (file) for specified client")
-options, client_names = parser.parse_args()
-
-clients=[]
-for name in client_names:
-    for path, client in mandos_clients.iteritems():
-        if client['name'] == name:
-            client_objc = bus.get_object(busname, path)
-            clients.append(dbus.Interface(client_objc,
-                                          dbus_interface
-                                          = client_interface))
-            break
-    else:
-        print >> sys.stderr, "Client not found on server: %r" % name
-        sys.exit(1)
-
-if not clients:
-    keywords = defaultkeywords
-    if options.all:
-        keywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
-                    'created', 'interval', 'host', 'fingerprint',
-                    'checker_running', 'last_enabled', 'checker')
-    print_clients(mandos_clients.values())
-    
-for client in clients:
-    if options.enable:
-        client.Enable()
-    if options.disable:
-        client.Disable()
-    if options.bump_timeout:
-        client.BumpTimeout()
-    if options.start_checker:
-        client.StartChecker()
-    if options.stop_checker:
-        client.StopChecker()
-    if options.is_valid:
-        sys.exit(0 if client.IsStillValid() else 1)
-    if options.checker:
-        client.SetChecker(options.checker)
-    if options.host:
-        client.SetHost(options.host)
-    if options.interval:
-        client.SetInterval(datetime_to_milliseconds
-                           (string_to_delta(options.interval)))
-    if options.timeout:
-        client.SetTimeout(datetime_to_milliseconds
-                          (string_to_delta(options.timeout)))
-    if options.secret:
-        client.SetSecret(dbus.ByteArray(open(options.secret, 'rb').read()))
-    

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-01-15 04:55:10 +0000
+++ mandos-keygen	2008-10-12 07:27:43 +0000
@@ -2,8 +2,7 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008,2009 Teddy Hogeborn
-# Copyright © 2008,2009 Björn Påhlsson
+# Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.4"
+VERSION="1.0.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2009-01-04 21:54:55 +0000
+++ mandos-keygen.xml	2008-10-04 01:55:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2008-12-29 02:44:54 +0000
+++ mandos-options.xml	2008-09-30 03:19:39 +0000
@@ -65,11 +65,5 @@
     rename itself to <quote><literal>Mandos #2</literal></quote>, and
     so on; therefore, this option is not needed in that case.
   </para>
-
-  <para id="dbus">
-    This option controls whether the server will provide a D-Bus
-    system bus interface.  The default is to provide such an
-    interface.
-  </para>
   
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2008-12-29 02:44:54 +0000
+++ mandos.conf	2008-08-18 23:55:28 +0000
@@ -36,6 +36,3 @@
 # If there are name collisions on the same *network*, the server will
 # rename itself to "Mandos #2", etc.
 ;servicename = Mandos
-
-# Whether to provide a D-Bus system bus interface or not
-;use_dbus = True

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2009-01-04 21:54:55 +0000
+++ mandos.conf.xml	2008-09-30 07:23:39 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-09-30">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -33,7 +33,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -131,17 +130,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>use_dbus<literal> = </literal>{ <literal
-	  >1</literal> | <literal>yes</literal> | <literal
-	  >true</literal> | <literal>on</literal> | <literal
-	  >0</literal> | <literal>no</literal> | <literal
-	  >false</literal> | <literal>off</literal> }</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -184,7 +172,6 @@
 debug = true
 priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 servicename = Daena
-use_dbus = False
       </programlisting>
     </informalexample>
   </refsect1>

=== removed file 'mandos.lsm'
--- mandos.lsm	2009-01-15 04:55:10 +0000
+++ mandos.lsm	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-Begin4
-Title:		Mandos
-Version:	1.0.4
-Entered-date:	2009-01-15
-Description:	The Mandos system allows computers to have encrypted
-root file systems and at the same time be capable of remote and/or
-unattended reboots.
-Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      94K mandos_1.0.4.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		94K mandos_1.0.4.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
-various other libraries.  While made for Debian GNU/Linux, it is
-probably portable to other distributions, but not other Unixes.
-Copying-policy: GNU General Public License version 3.0 or later
-End

=== modified file 'mandos.xml'
--- mandos.xml	2009-01-05 23:26:06 +0000
+++ mandos.xml	2008-10-04 01:55:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-01-14 14:20:17 +0000
+++ plugin-runner.c	2008-09-30 07:23:39 +0000
@@ -2,8 +2,7 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -64,7 +63,6 @@
 				   sigprocmask(), SIG_BLOCK, SIGCHLD,
 				   SIG_UNBLOCK, kill() */
 #include <errno.h>		/* errno, EBADF */
-#include <inttypes.h>		/* intmax_t, SCNdMAX, PRIdMAX,  */
 
 #define BUFFER_SIZE 256
 
@@ -100,15 +98,15 @@
    or if none is found, creates a new one */
 static plugin *getplugin(char *name){
   /* Check for exiting plugin with that name */
-  for(plugin *p = plugin_list; p != NULL; p = p->next){
-    if((p->name == name)
-       or (p->name and name and (strcmp(p->name, name) == 0))){
+  for (plugin *p = plugin_list; p != NULL; p = p->next){
+    if ((p->name == name)
+	or (p->name and name and (strcmp(p->name, name) == 0))){
       return p;
     }
   }
   /* Create a new plugin */
   plugin *new_plugin = malloc(sizeof(plugin));
-  if(new_plugin == NULL){
+  if (new_plugin == NULL){
     return NULL;
   }
   char *copy_name = NULL;
@@ -125,7 +123,7 @@
 			   .next = plugin_list };
   
   new_plugin->argv = malloc(sizeof(char *) * 2);
-  if(new_plugin->argv == NULL){
+  if (new_plugin->argv == NULL){
     free(copy_name);
     free(new_plugin);
     return NULL;
@@ -231,7 +229,7 @@
       break;
     }
     if(pid == -1){
-      if(errno != ECHILD){
+      if (errno != ECHILD){
 	perror("waitpid");
       }
       /* No child processes */
@@ -309,9 +307,7 @@
   struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
-  int ret, numchars, maxfd = 0;
-  ssize_t sret;
-  intmax_t tmpmax;
+  int ret, maxfd = 0;
   uid_t uid = 65534;
   gid_t gid = 65534;
   bool debug = false;
@@ -374,11 +370,11 @@
     { .name = NULL }
   };
   
-  error_t parse_opt(int key, char *arg, __attribute__((unused))
-		    struct argp_state *state) {
-    switch(key) {
+  error_t parse_opt (int key, char *arg, __attribute__((unused))
+		     struct argp_state *state) {
+    switch (key) {
     case 'g': 			/* --global-options */
-      if(arg != NULL){
+      if (arg != NULL){
 	char *p;
 	while((p = strsep(&arg, ",")) != NULL){
 	  if(p[0] == '\0'){
@@ -400,7 +396,7 @@
       }
       break;
     case 'o':			/* --options-for */
-      if(arg != NULL){
+      if (arg != NULL){
 	char *p_name = strsep(&arg, ":");
 	if(p_name[0] == '\0' or arg == NULL){
 	  break;
@@ -437,7 +433,7 @@
       }
       break;
     case 'd':			/* --disable */
-      if(arg != NULL){
+      if (arg != NULL){
 	plugin *p = getplugin(arg);
 	if(p == NULL){
 	  return ARGP_ERR_UNKNOWN;
@@ -446,7 +442,7 @@
       }
       break;
     case 'e':			/* --enable */
-      if(arg != NULL){
+      if (arg != NULL){
 	plugin *p = getplugin(arg);
 	if(p == NULL){
 	  return ARGP_ERR_UNKNOWN;
@@ -465,32 +461,14 @@
       /* This is already done by parse_opt_config_file() */
       break;
     case 130:			/* --userid */
-      ret = sscanf(arg, "%" SCNdMAX "%n", &tmpmax, &numchars);
-      if(ret < 1 or tmpmax != (uid_t)tmpmax
-	 or arg[numchars] != '\0'){
-	fprintf(stderr, "Bad user ID number: \"%s\", using %"
-		PRIdMAX "\n", arg, (intmax_t)uid);
-      } else {
-	uid = (uid_t)tmpmax;
-      }
+      uid = (uid_t)strtol(arg, NULL, 10);
       break;
     case 131:			/* --groupid */
-      ret = sscanf(arg, "%" SCNdMAX "%n", &tmpmax, &numchars);
-      if(ret < 1 or tmpmax != (gid_t)tmpmax
-	 or arg[numchars] != '\0'){
-	fprintf(stderr, "Bad group ID number: \"%s\", using %"
-		PRIdMAX "\n", arg, (intmax_t)gid);
-      } else {
-	gid = (gid_t)tmpmax;
-      }
+      gid = (gid_t)strtol(arg, NULL, 10);
       break;
     case 132:			/* --debug */
       debug = true;
       break;
-/*
- * When adding more options before this line, remember to also add a
- * "case" to the "parse_opt_config_file" function below.
- */
     case ARGP_KEY_ARG:
       /* Cryptsetup always passes an argument, which is an empty
 	 string if "none" was specified in /etc/crypttab.  So if
@@ -509,10 +487,10 @@
   
   /* This option parser is the same as parse_opt() above, except it
      ignores everything but the --config-file option. */
-  error_t parse_opt_config_file(int key, char *arg,
-				__attribute__((unused))
-				struct argp_state *state) {
-    switch(key) {
+  error_t parse_opt_config_file (int key, char *arg,
+				 __attribute__((unused))
+				 struct argp_state *state) {
+    switch (key) {
     case 'g': 			/* --global-options */
     case 'G':			/* --global-env */
     case 'o':			/* --options-for */
@@ -545,10 +523,10 @@
 		       .args_doc = "",
 		       .doc = "Mandos plugin runner -- Run plugins" };
   
-  /* Parse using parse_opt_config_file() in order to get the custom
+  /* Parse using the parse_opt_config_file in order to get the custom
      config file location, if any. */
-  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if(ret == ARGP_ERR_UNKNOWN){
+  ret = argp_parse (&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
+  if (ret == ARGP_ERR_UNKNOWN){
     fprintf(stderr, "Unknown error while parsing arguments\n");
     exitstatus = EXIT_FAILURE;
     goto fallback;
@@ -558,7 +536,7 @@
   argp.parser = parse_opt;
   
   /* Open the configfile if available */
-  if(argfile == NULL){
+  if (argfile == NULL){
     conffp = fopen(AFILE, "r");
   } else {
     conffp = fopen(argfile, "r");
@@ -567,6 +545,7 @@
     char *org_line = NULL;
     char *p, *arg, *new_arg, *line;
     size_t size = 0;
+    ssize_t sret;
     const char whitespace_delims[] = " \r\t\f\v\n";
     const char comment_delim[] = "#";
 
@@ -619,7 +598,7 @@
   } else {
     /* Check for harmful errors and go to fallback. Other errors might
        not affect opening plugins */
-    if(errno == EMFILE or errno == ENFILE or errno == ENOMEM){
+    if (errno == EMFILE or errno == ENFILE or errno == ENOMEM){
       perror("fopen");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -628,9 +607,9 @@
   /* If there was any arguments from configuration file,
      pass them to parser as command arguments */
   if(custom_argv != NULL){
-    ret = argp_parse(&argp, custom_argc, custom_argv, ARGP_IN_ORDER,
-		     0, NULL);
-    if(ret == ARGP_ERR_UNKNOWN){
+    ret = argp_parse (&argp, custom_argc, custom_argv, ARGP_IN_ORDER,
+		      0, NULL);
+    if (ret == ARGP_ERR_UNKNOWN){
       fprintf(stderr, "Unknown error while parsing arguments\n");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -639,8 +618,8 @@
   
   /* Parse actual command line arguments, to let them override the
      config file */
-  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if(ret == ARGP_ERR_UNKNOWN){
+  ret = argp_parse (&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
+  if (ret == ARGP_ERR_UNKNOWN){
     fprintf(stderr, "Unknown error while parsing arguments\n");
     exitstatus = EXIT_FAILURE;
     goto fallback;
@@ -653,7 +632,7 @@
       for(char **a = p->argv; *a != NULL; a++){
 	fprintf(stderr, "\tArg: %s\n", *a);
       }
-      fprintf(stderr, "...and %d environment variables\n", p->envc);
+      fprintf(stderr, "...and %u environment variables\n", p->envc);
       for(char **a = p->environ; *a != NULL; a++){
 	fprintf(stderr, "\t%s\n", *a);
       }
@@ -662,15 +641,15 @@
   
   /* Strip permissions down to nobody */
   ret = setuid(uid);
-  if(ret == -1){
+  if (ret == -1){
     perror("setuid");
   }  
   setgid(gid);
-  if(ret == -1){
+  if (ret == -1){
     perror("setgid");
   }
   
-  if(plugindir == NULL){
+  if (plugindir == NULL){
     dir = opendir(PDIR);
   } else {
     dir = opendir(plugindir);
@@ -703,7 +682,7 @@
     
     /* All directory entries have been processed */
     if(dirst == NULL){
-      if(errno == EBADF){
+      if (errno == EBADF){
 	perror("readdir");
 	exitstatus = EXIT_FAILURE;
 	goto fallback;
@@ -721,7 +700,6 @@
       
       const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
 					   ".dpkg-old",
-					   ".dpkg-bak",
 					   ".dpkg-divert", NULL };
       for(const char **pre = bad_prefixes; *pre != NULL; pre++){
 	size_t pre_len = strlen(*pre);
@@ -769,14 +747,14 @@
     }
     
     ret = stat(filename, &st);
-    if(ret == -1){
+    if (ret == -1){
       perror("stat");
       free(filename);
       continue;
     }
 
     /* Ignore non-executable files */
-    if(not S_ISREG(st.st_mode) or (access(filename, X_OK) != 0)){
+    if (not S_ISREG(st.st_mode)	or (access(filename, X_OK) != 0)){
       if(debug){
 	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
 		" with bad type or mode\n", filename);
@@ -829,7 +807,7 @@
     
     int pipefd[2];
     ret = pipe(pipefd);
-    if(ret == -1){
+    if (ret == -1){
       perror("pipe");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -848,7 +826,7 @@
       goto fallback;
     }
     /* Block SIGCHLD until process is safely in process list */
-    ret = sigprocmask(SIG_BLOCK, &sigchld_action.sa_mask, NULL);
+    ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
@@ -902,9 +880,9 @@
     close(pipefd[1]);		/* Close unused write end of pipe */
     free(filename);
     plugin *new_plugin = getplugin(dirst->d_name);
-    if(new_plugin == NULL){
+    if (new_plugin == NULL){
       perror("getplugin");
-      ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
+      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
         perror("sigprocmask");
       }
@@ -917,7 +895,7 @@
     
     /* Unblock SIGCHLD so signal handler can be run if this process
        has already completed */
-    ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
+    ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
@@ -926,7 +904,7 @@
     
     FD_SET(new_plugin->fd, &rfds_all);
     
-    if(maxfd < new_plugin->fd){
+    if (maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
   }
@@ -949,7 +927,7 @@
   while(plugin_list){
     fd_set rfds = rfds_all;
     int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-    if(select_ret == -1){
+    if (select_ret == -1){
       perror("select");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -966,16 +944,16 @@
 
 	  if(debug){
 	    if(WIFEXITED(proc->status)){
-	      fprintf(stderr, "Plugin %" PRIdMAX " exited with status"
-		      " %d\n", (intmax_t) (proc->pid),
+	      fprintf(stderr, "Plugin %u exited with status %d\n",
+		      (unsigned int) (proc->pid),
 		      WEXITSTATUS(proc->status));
 	    } else if(WIFSIGNALED(proc->status)) {
-	      fprintf(stderr, "Plugin %" PRIdMAX " killed by signal"
-		      " %d\n", (intmax_t) (proc->pid),
+	      fprintf(stderr, "Plugin %u killed by signal %d\n",
+		      (unsigned int) (proc->pid),
 		      WTERMSIG(proc->status));
 	    } else if(WCOREDUMP(proc->status)){
-	      fprintf(stderr, "Plugin %" PRIdMAX " dumped core\n",
-		      (intmax_t) (proc->pid));
+	      fprintf(stderr, "Plugin %d dumped core\n",
+		      (unsigned int) (proc->pid));
 	    }
 	  }
 	  
@@ -995,8 +973,8 @@
 	  proc = next_plugin;
 	  
 	  /* We are done modifying process list, so unblock signal */
-	  ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask,
-			    NULL);
+	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
+			     NULL);
 	  if(ret < 0){
 	    perror("sigprocmask");
 	    exitstatus = EXIT_FAILURE;
@@ -1031,7 +1009,7 @@
       if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
 	proc->buffer = realloc(proc->buffer, proc->buffer_size
 			       + (size_t) BUFFER_SIZE);
-	if(proc->buffer == NULL){
+	if (proc->buffer == NULL){
 	  perror("malloc");
 	  exitstatus = EXIT_FAILURE;
 	  goto fallback;
@@ -1039,18 +1017,18 @@
 	proc->buffer_size += BUFFER_SIZE;
       }
       /* Read from the process */
-      sret = read(proc->fd, proc->buffer + proc->buffer_length,
-		  BUFFER_SIZE);
-      if(sret < 0){
+      ret = read(proc->fd, proc->buffer + proc->buffer_length,
+		 BUFFER_SIZE);
+      if(ret < 0){
 	/* Read error from this process; ignore the error */
 	proc = proc->next;
 	continue;
       }
-      if(sret == 0){
+      if(ret == 0){
 	/* got EOF */
 	proc->eof = true;
       } else {
-	proc->buffer_length += (size_t) sret;
+	proc->buffer_length += (size_t) ret;
       }
     }
   }

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-04 21:54:55 +0000
+++ plugin-runner.xml	2008-09-30 07:23:39 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-09-30">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2009-01-10 06:00:50 +0000
+++ plugins.d/askpass-fifo.c	2008-09-26 19:47:21 +0000
@@ -1,28 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Askpass-FIFO - Read a password from a FIFO and output it
- * 
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
 #include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
@@ -43,14 +18,14 @@
   
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
-  ret = (int)TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
+  ret = TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
   if(ret == -1 and errno != EEXIST){
     perror("mkfifo");
     return EXIT_FAILURE;
   }
   
   /* Open FIFO */
-  int fifo_fd = (int)TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
+  int fifo_fd = TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
   if(fifo_fd == -1){
     perror("open");
     return EXIT_FAILURE;

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/askpass-fifo.xml	2008-10-04 20:09:53 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-01-14 14:20:17 +0000
+++ plugins.d/mandos-client.c	2008-09-30 07:23:39 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Mandos-client - get and decrypt data from a Mandos server
+ * Mandos client - get and decrypt data from a Mandos server
  *
  * This program is partly derived from an example program for an Avahi
  * service browser, downloaded from
@@ -9,8 +9,7 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -36,7 +35,7 @@
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror(), sscanf */
+				   stdout, ferror() */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
@@ -48,16 +47,14 @@
 #include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, INET6_ADDRSTRLEN,
-				   uid_t, gid_t, open(), opendir(),
-				   DIR */
+				   uid_t, gid_t, open(), opendir(), DIR */
 #include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   struct in6_addr, inet_pton(),
 				   connect() */
 #include <fcntl.h>		/* open() */
-#include <dirent.h>		/* opendir(), struct dirent, readdir()
-				 */
-#include <inttypes.h>		/* PRIu16, intmax_t, SCNdMAX */
+#include <dirent.h>		/* opendir(), struct dirent, readdir() */
+#include <inttypes.h>		/* PRIu16 */
 #include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno */
 #include <time.h>		/* time() */
@@ -69,7 +66,7 @@
 				   getuid(), getgid(), setuid(),
 				   setgid() */
 #include <arpa/inet.h>		/* inet_pton(), htons */
-#include <iso646.h>		/* not, and, or */
+#include <iso646.h>		/* not, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
 				   argp_parse(), ARGP_KEY_ARG,
@@ -92,8 +89,7 @@
 				   gnutls_*
 				   init_gnutls_session(),
 				   GNUTLS_* */
-#include <gnutls/openpgp.h>
-			  /* gnutls_certificate_set_openpgp_key_file(),
+#include <gnutls/openpgp.h>     /* gnutls_certificate_set_openpgp_key_file(),
 				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
@@ -132,9 +128,9 @@
  */
 size_t adjustbuffer(char **buffer, size_t buffer_length,
 		  size_t buffer_capacity){
-  if(buffer_length + BUFFER_SIZE > buffer_capacity){
+  if (buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
-    if(buffer == NULL){
+    if (buffer == NULL){
       return 0;
     }
     buffer_capacity += BUFFER_SIZE;
@@ -159,27 +155,27 @@
     int fd;
     gpgme_data_t pgp_data;
     
-    fd = (int)TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
+    fd = TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
     if(fd == -1){
       perror("open");
       return false;
     }
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
-    if(rc != GPG_ERR_NO_ERROR){
+    if (rc != GPG_ERR_NO_ERROR){
       fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc->ctx, pgp_data);
-    if(rc != GPG_ERR_NO_ERROR){
+    if (rc != GPG_ERR_NO_ERROR){
       fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
-    ret = (int)TEMP_FAILURE_RETRY(close(fd));
+    ret = TEMP_FAILURE_RETRY(close(fd));
     if(ret == -1){
       perror("close");
     }
@@ -187,22 +183,22 @@
     return true;
   }
   
-  if(debug){
+  if (debug){
     fprintf(stderr, "Initialize gpgme\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
-  if(rc != GPG_ERR_NO_ERROR){
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
     /* Set GPGME home directory for the OpenPGP engine only */
-  rc = gpgme_get_engine_info(&engine_info);
-  if(rc != GPG_ERR_NO_ERROR){
+  rc = gpgme_get_engine_info (&engine_info);
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
@@ -222,13 +218,13 @@
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc->ctx));
-  if(rc != GPG_ERR_NO_ERROR){
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
-  if(not import_key(pubkey) or not import_key(seckey)){
+  if (not import_key(pubkey) or not import_key(seckey)){
     return false;
   }
   
@@ -239,24 +235,24 @@
  * Decrypt OpenPGP data.
  * Returns -1 on error
  */
-static ssize_t pgp_packet_decrypt(const mandos_context *mc,
-				  const char *cryptotext,
-				  size_t crypto_size,
-				  char **plaintext){
+static ssize_t pgp_packet_decrypt (const mandos_context *mc,
+				   const char *cryptotext,
+				   size_t crypto_size,
+				   char **plaintext){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_error_t rc;
   ssize_t ret;
   size_t plaintext_capacity = 0;
   ssize_t plaintext_length = 0;
   
-  if(debug){
+  if (debug){
     fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
-  if(rc != GPG_ERR_NO_ERROR){
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
@@ -264,7 +260,7 @@
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
-  if(rc != GPG_ERR_NO_ERROR){
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
@@ -274,14 +270,14 @@
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
   rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
-  if(rc != GPG_ERR_NO_ERROR){
+  if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
-    if(debug){
+    if (debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc->ctx);
-      if(result == NULL){
+      if (result == NULL){
 	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
 	fprintf(stderr, "Unsupported algorithm: %s\n",
@@ -314,7 +310,7 @@
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
-  if(gpgme_data_seek(dh_plain, (off_t)0, SEEK_SET) == -1){
+  if (gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET) == -1){
     perror("gpgme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
@@ -325,7 +321,7 @@
     plaintext_capacity = adjustbuffer(plaintext,
 				      (size_t)plaintext_length,
 				      plaintext_capacity);
-    if(plaintext_capacity == 0){
+    if (plaintext_capacity == 0){
 	perror("adjustbuffer");
 	plaintext_length = -1;
 	goto decrypt_end;
@@ -334,7 +330,7 @@
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
 			  BUFFER_SIZE);
     /* Print the data, if any */
-    if(ret == 0){
+    if (ret == 0){
       /* EOF */
       break;
     }
@@ -364,10 +360,9 @@
   return plaintext_length;
 }
 
-static const char * safer_gnutls_strerror(int value) {
-  const char *ret = gnutls_strerror(value); /* Spurious warning from
-					       -Wunreachable-code */
-  if(ret == NULL)
+static const char * safer_gnutls_strerror (int value) {
+  const char *ret = gnutls_strerror (value); /* Spurious warning */
+  if (ret == NULL)
     ret = "(unknown)";
   return ret;
 }
@@ -388,13 +383,13 @@
   }
   
   ret = gnutls_global_init();
-  if(ret != GNUTLS_E_SUCCESS) {
-    fprintf(stderr, "GnuTLS global_init: %s\n",
-	    safer_gnutls_strerror(ret));
+  if (ret != GNUTLS_E_SUCCESS) {
+    fprintf (stderr, "GnuTLS global_init: %s\n",
+	     safer_gnutls_strerror(ret));
     return -1;
   }
   
-  if(debug){
+  if (debug){
     /* "Use a log level over 10 to enable all debugging options."
      * - GnuTLS manual
      */
@@ -404,13 +399,11 @@
   
   /* OpenPGP credentials */
   gnutls_certificate_allocate_credentials(&mc->cred);
-  if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS memory error: %s\n", /* Spurious warning
-						  * from
-						  * -Wunreachable-code
-						  */
-	    safer_gnutls_strerror(ret));
-    gnutls_global_deinit();
+  if (ret != GNUTLS_E_SUCCESS){
+    fprintf (stderr, "GnuTLS memory error: %s\n", /* Spurious
+						     warning */
+	     safer_gnutls_strerror(ret));
+    gnutls_global_deinit ();
     return -1;
   }
   
@@ -423,7 +416,7 @@
   ret = gnutls_certificate_set_openpgp_key_file
     (mc->cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
-  if(ret != GNUTLS_E_SUCCESS) {
+  if (ret != GNUTLS_E_SUCCESS) {
     fprintf(stderr,
 	    "Error[%d] while reading the OpenPGP key pair ('%s',"
 	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
@@ -434,15 +427,15 @@
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc->dh_params);
-  if(ret != GNUTLS_E_SUCCESS) {
-    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
-	    " %s\n", safer_gnutls_strerror(ret));
+  if (ret != GNUTLS_E_SUCCESS) {
+    fprintf (stderr, "Error in GnuTLS DH parameter initialization:"
+	     " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
-  if(ret != GNUTLS_E_SUCCESS) {
-    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
-	    safer_gnutls_strerror(ret));
+  if (ret != GNUTLS_E_SUCCESS) {
+    fprintf (stderr, "Error in GnuTLS prime generation: %s\n",
+	     safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -463,7 +456,7 @@
   int ret;
   /* GnuTLS session creation */
   ret = gnutls_init(session, GNUTLS_SERVER);
-  if(ret != GNUTLS_E_SUCCESS){
+  if (ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
   }
@@ -471,29 +464,29 @@
   {
     const char *err;
     ret = gnutls_priority_set_direct(*session, mc->priority, &err);
-    if(ret != GNUTLS_E_SUCCESS) {
+    if (ret != GNUTLS_E_SUCCESS) {
       fprintf(stderr, "Syntax error at: %s\n", err);
       fprintf(stderr, "GnuTLS error: %s\n",
 	      safer_gnutls_strerror(ret));
-      gnutls_deinit(*session);
+      gnutls_deinit (*session);
       return -1;
     }
   }
   
   ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
 			       mc->cred);
-  if(ret != GNUTLS_E_SUCCESS) {
+  if (ret != GNUTLS_E_SUCCESS) {
     fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
 	    safer_gnutls_strerror(ret));
-    gnutls_deinit(*session);
+    gnutls_deinit (*session);
     return -1;
   }
   
   /* ignore client certificate if any. */
-  gnutls_certificate_server_set_request(*session,
-					GNUTLS_CERT_IGNORE);
+  gnutls_certificate_server_set_request (*session,
+					 GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits(*session, mc->dh_bits);
+  gnutls_dh_set_prime_bits (*session, mc->dh_bits);
   
   return 0;
 }
@@ -507,7 +500,6 @@
 				      AvahiIfIndex if_index,
 				      mandos_context *mc){
   int ret, tcp_sd;
-  ssize_t sret;
   union { struct sockaddr in; struct sockaddr_in6 in6; } to;
   char *buffer = NULL;
   char *decrypted_buffer;
@@ -519,8 +511,8 @@
   char interface[IF_NAMESIZE];
   gnutls_session_t session;
   
-  ret = init_gnutls_session(mc, &session);
-  if(ret != 0){
+  ret = init_gnutls_session (mc, &session);
+  if (ret != 0){
     return -1;
   }
   
@@ -548,7 +540,7 @@
   /* It would be nice to have a way to detect if we were passed an
      IPv4 address here.   Now we assume an IPv6 address. */
   ret = inet_pton(AF_INET6, ip, &to.in6.sin6_addr);
-  if(ret < 0 ){
+  if (ret < 0 ){
     perror("inet_pton");
     return -1;
   }
@@ -556,9 +548,7 @@
     fprintf(stderr, "Bad address: %s\n", ip);
     return -1;
   }
-  to.in6.sin6_port = htons(port); /* Spurious warnings from
-				     -Wconversion and
-				     -Wunreachable-code */
+  to.in6.sin6_port = htons(port); /* Spurious warning */
   
   to.in6.sin6_scope_id = (uint32_t)if_index;
   
@@ -577,18 +567,18 @@
   }
   
   ret = connect(tcp_sd, &to.in, sizeof(to));
-  if(ret < 0){
+  if (ret < 0){
     perror("connect");
     return -1;
   }
   
   const char *out = mandos_protocol_version;
   written = 0;
-  while(true){
+  while (true){
     size_t out_size = strlen(out);
-    ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
+    ret = TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
 				   out_size - written));
-    if(ret == -1){
+    if (ret == -1){
       perror("write");
       retval = -1;
       goto mandos_end;
@@ -597,7 +587,7 @@
     if(written < out_size){
       continue;
     } else {
-      if(out == mandos_protocol_version){
+      if (out == mandos_protocol_version){
 	written = 0;
 	out = "\r\n";
       } else {
@@ -610,16 +600,16 @@
     fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
-  gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
+  gnutls_transport_set_ptr (session, (gnutls_transport_ptr_t) tcp_sd);
   
   do{
-    ret = gnutls_handshake(session);
+    ret = gnutls_handshake (session);
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
   
-  if(ret != GNUTLS_E_SUCCESS){
+  if (ret != GNUTLS_E_SUCCESS){
     if(debug){
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
-      gnutls_perror(ret);
+      gnutls_perror (ret);
     }
     retval = -1;
     goto mandos_end;
@@ -635,29 +625,29 @@
   while(true){
     buffer_capacity = adjustbuffer(&buffer, buffer_length,
 				   buffer_capacity);
-    if(buffer_capacity == 0){
+    if (buffer_capacity == 0){
       perror("adjustbuffer");
       retval = -1;
       goto mandos_end;
     }
     
-    sret = gnutls_record_recv(session, buffer+buffer_length,
-			      BUFFER_SIZE);
-    if(sret == 0){
+    ret = gnutls_record_recv(session, buffer+buffer_length,
+			     BUFFER_SIZE);
+    if (ret == 0){
       break;
     }
-    if(sret < 0){
-      switch(sret){
+    if (ret < 0){
+      switch(ret){
       case GNUTLS_E_INTERRUPTED:
       case GNUTLS_E_AGAIN:
 	break;
       case GNUTLS_E_REHANDSHAKE:
 	do{
-	  ret = gnutls_handshake(session);
+	  ret = gnutls_handshake (session);
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
-	if(ret < 0){
+	if (ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
-	  gnutls_perror(ret);
+	  gnutls_perror (ret);
 	  retval = -1;
 	  goto mandos_end;
 	}
@@ -666,11 +656,11 @@
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	retval = -1;
-	gnutls_bye(session, GNUTLS_SHUT_RDWR);
+	gnutls_bye (session, GNUTLS_SHUT_RDWR);
 	goto mandos_end;
       }
     } else {
-      buffer_length += (size_t) sret;
+      buffer_length += (size_t) ret;
     }
   }
   
@@ -678,18 +668,18 @@
     fprintf(stderr, "Closing TLS session\n");
   }
   
-  gnutls_bye(session, GNUTLS_SHUT_RDWR);
+  gnutls_bye (session, GNUTLS_SHUT_RDWR);
   
-  if(buffer_length > 0){
+  if (buffer_length > 0){
     decrypted_buffer_size = pgp_packet_decrypt(mc, buffer,
 					       buffer_length,
 					       &decrypted_buffer);
-    if(decrypted_buffer_size >= 0){
+    if (decrypted_buffer_size >= 0){
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
-	ret = (int)fwrite(decrypted_buffer + written, 1,
-			  (size_t)decrypted_buffer_size - written,
-			  stdout);
+	ret = (int)fwrite (decrypted_buffer + written, 1,
+			   (size_t)decrypted_buffer_size - written,
+			   stdout);
 	if(ret == 0 and ferror(stdout)){
 	  if(debug){
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
@@ -712,11 +702,11 @@
   
  mandos_end:
   free(buffer);
-  ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
+  ret = TEMP_FAILURE_RETRY(close(tcp_sd));
   if(ret == -1){
     perror("close");
   }
-  gnutls_deinit(session);
+  gnutls_deinit (session);
   return retval;
 }
 
@@ -740,7 +730,7 @@
   /* Called whenever a service has been resolved successfully or
      timed out */
   
-  switch(event) {
+  switch (event) {
   default:
   case AVAHI_RESOLVER_FAILURE:
     fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
@@ -754,11 +744,11 @@
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
 	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
-		ip, (intmax_t)interface, port);
+		PRIu16 ") on port %d\n", name, host_name, ip,
+		interface, port);
       }
       int ret = start_mandos_communication(ip, port, interface, mc);
-      if(ret == 0){
+      if (ret == 0){
 	avahi_simple_poll_quit(mc->simple_poll);
       }
     }
@@ -782,7 +772,7 @@
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
   
-  switch(event) {
+  switch (event) {
   default:
   case AVAHI_BROWSER_FAILURE:
     
@@ -797,7 +787,7 @@
        the callback function is called the Avahi server will free the
        resolver for us. */
     
-    if(!(avahi_s_service_resolver_new(mc->server, interface,
+    if (!(avahi_s_service_resolver_new(mc->server, interface,
 				       protocol, name, type, domain,
 				       AVAHI_PROTO_INET6, 0,
 				       resolve_callback, mc)))
@@ -821,8 +811,6 @@
     AvahiSServiceBrowser *sb = NULL;
     int error;
     int ret;
-    intmax_t tmpmax;
-    int numchars;
     int exitcode = EXIT_SUCCESS;
     const char *interface = "eth0";
     struct ifreq network;
@@ -874,9 +862,11 @@
 	{ .name = NULL }
       };
       
-      error_t parse_opt(int key, char *arg,
-			struct argp_state *state) {
-	switch(key) {
+      error_t parse_opt (int key, char *arg,
+			 struct argp_state *state) {
+	/* Get the INPUT argument from `argp_parse', which we know is
+	   a pointer to our plugin list pointer. */
+	switch (key) {
 	case 128:		/* --debug */
 	  debug = true;
 	  break;
@@ -893,19 +883,18 @@
 	  pubkey = arg;
 	  break;
 	case 129:		/* --dh-bits */
-	  ret = sscanf(arg, "%" SCNdMAX "%n", &tmpmax, &numchars);
-	  if(ret < 1 or tmpmax != (typeof(mc.dh_bits))tmpmax
-	     or arg[numchars] != '\0'){
-	    fprintf(stderr, "Bad number of DH bits\n");
+	  errno = 0;
+	  mc.dh_bits = (unsigned int) strtol(arg, NULL, 10);
+	  if (errno){
+	    perror("strtol");
 	    exit(EXIT_FAILURE);
 	  }
-	  mc.dh_bits = (typeof(mc.dh_bits))tmpmax;
 	  break;
 	case 130:		/* --priority */
 	  mc.priority = arg;
 	  break;
 	case ARGP_KEY_ARG:
-	  argp_usage(state);
+	  argp_usage (state);
 	case ARGP_KEY_END:
 	  break;
 	default:
@@ -918,8 +907,8 @@
 			   .args_doc = "",
 			   .doc = "Mandos client -- Get and decrypt"
 			   " passwords from a Mandos server" };
-      ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
-      if(ret == ARGP_ERR_UNKNOWN){
+      ret = argp_parse (&argp, argc, argv, 0, 0, NULL);
+      if (ret == ARGP_ERR_UNKNOWN){
 	fprintf(stderr, "Unknown error while parsing arguments\n");
 	exitcode = EXIT_FAILURE;
 	goto end;
@@ -950,7 +939,7 @@
 	  goto end;
 	}
       }
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      ret = TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
 	perror("close");
       }
@@ -960,17 +949,17 @@
     gid = getgid();
     
     ret = setuid(uid);
-    if(ret == -1){
+    if (ret == -1){
       perror("setuid");
     }
     
     setgid(gid);
-    if(ret == -1){
+    if (ret == -1){
       perror("setgid");
     }
     
     ret = init_gnutls_global(&mc, pubkey, seckey);
-    if(ret == -1){
+    if (ret == -1){
       fprintf(stderr, "init_gnutls_global failed\n");
       exitcode = EXIT_FAILURE;
       goto end;
@@ -1007,15 +996,13 @@
 	exitcode = EXIT_FAILURE;
 	goto end;
       }
-      uint16_t port;
-      ret = sscanf(address+1, "%" SCNdMAX "%n", &tmpmax, &numchars);
-      if(ret < 1 or tmpmax != (uint16_t)tmpmax
-	 or address[numchars+1] != '\0'){
-	fprintf(stderr, "Bad port number\n");
+      errno = 0;
+      uint16_t port = (uint16_t) strtol(address+1, NULL, 10);
+      if(errno){
+	perror("Bad port number");
 	exitcode = EXIT_FAILURE;
 	goto end;
       }
-      port = (uint16_t)tmpmax;
       *address = '\0';
       address = connect_to;
       ret = start_mandos_communication(address, port, if_index, &mc);
@@ -1027,7 +1014,7 @@
       goto end;
     }
     
-    if(not debug){
+    if (not debug){
       avahi_set_log_function(empty_log);
     }
     
@@ -1036,7 +1023,7 @@
     
     /* Allocate main Avahi loop object */
     mc.simple_poll = avahi_simple_poll_new();
-    if(mc.simple_poll == NULL) {
+    if (mc.simple_poll == NULL) {
         fprintf(stderr, "Avahi: Failed to create simple poll"
 		" object.\n");
 	exitcode = EXIT_FAILURE;
@@ -1062,7 +1049,7 @@
     }
     
     /* Check if creating the Avahi server object succeeded */
-    if(mc.server == NULL) {
+    if (mc.server == NULL) {
         fprintf(stderr, "Failed to create Avahi server: %s\n",
 		avahi_strerror(error));
 	exitcode = EXIT_FAILURE;
@@ -1074,7 +1061,7 @@
 				     AVAHI_PROTO_INET6,
 				     "_mandos._tcp", NULL, 0,
 				     browse_callback, &mc);
-    if(sb == NULL) {
+    if (sb == NULL) {
         fprintf(stderr, "Failed to create service browser: %s\n",
 		avahi_strerror(avahi_server_errno(mc.server)));
 	exitcode = EXIT_FAILURE;
@@ -1083,7 +1070,7 @@
     
     /* Run the main loop */
     
-    if(debug){
+    if (debug){
       fprintf(stderr, "Starting Avahi loop search\n");
     }
     
@@ -1091,23 +1078,23 @@
     
  end:
     
-    if(debug){
+    if (debug){
       fprintf(stderr, "%s exiting\n", argv[0]);
     }
     
     /* Cleanup things */
-    if(sb != NULL)
+    if (sb != NULL)
         avahi_s_service_browser_free(sb);
     
-    if(mc.server != NULL)
+    if (mc.server != NULL)
         avahi_server_free(mc.server);
     
-    if(mc.simple_poll != NULL)
+    if (mc.simple_poll != NULL)
         avahi_simple_poll_free(mc.simple_poll);
     
-    if(gnutls_initalized){
+    if (gnutls_initalized){
       gnutls_certificate_free_credentials(mc.cred);
-      gnutls_global_deinit();
+      gnutls_global_deinit ();
       gnutls_dh_params_deinit(mc.dh_params);
     }
     
@@ -1121,16 +1108,14 @@
       struct dirent *direntry;
       d = opendir(tempdir);
       if(d == NULL){
-	if(errno != ENOENT){
-	  perror("opendir");
-	}
+	perror("opendir");
       } else {
 	while(true){
 	  direntry = readdir(d);
 	  if(direntry == NULL){
 	    break;
 	  }
-	  if(direntry->d_type == DT_REG){
+	  if (direntry->d_type == DT_REG){
 	    char *fullname = NULL;
 	    ret = asprintf(&fullname, "%s/%s", tempdir,
 			   direntry->d_name);
@@ -1149,7 +1134,7 @@
 	closedir(d);
       }
       ret = rmdir(tempdir);
-      if(ret == -1 and errno != ENOENT){
+      if(ret == -1){
 	perror("rmdir");
       }
     }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/mandos-client.xml	2008-10-04 01:55:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-01-13 04:35:19 +0000
+++ plugins.d/password-prompt.c	2008-09-30 07:23:39 +0000
@@ -1,9 +1,8 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Password-prompt - Read a password from the terminal and print it
- * 
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
+ * Passprompt - Read a password from the terminal and print it
+ *
+ * Copyright © 2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -79,8 +78,10 @@
 	.doc = "Debug mode", .group = 3 },
       { .name = NULL }
     };
-    
+  
     error_t parse_opt (int key, char *arg, struct argp_state *state) {
+      /* Get the INPUT argument from `argp_parse', which we know is a
+	 pointer to our plugin list pointer. */
       switch (key) {
       case 'p':
 	prefix = arg;
@@ -89,7 +90,7 @@
 	debug = true;
 	break;
       case ARGP_KEY_ARG:
-	argp_usage(state);
+	argp_usage (state);
 	break;
       case ARGP_KEY_END:
 	break;
@@ -98,26 +99,26 @@
       }
       return 0;
     }
-    
+  
     struct argp argp = { .options = options, .parser = parse_opt,
 			 .args_doc = "",
 			 .doc = "Mandos password-prompt -- Read and"
 			 " output a password" };
-    ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
-    if(ret == ARGP_ERR_UNKNOWN){
+    ret = argp_parse (&argp, argc, argv, 0, 0, NULL);
+    if (ret == ARGP_ERR_UNKNOWN){
       fprintf(stderr, "Unknown error while parsing arguments\n");
       return EXIT_FAILURE;
     }
   }
-  
-  if(debug){
+    
+  if (debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
-  if(debug){
+  if (debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }
   
-  if(tcgetattr(STDIN_FILENO, &t_old) != 0){
+  if (tcgetattr(STDIN_FILENO, &t_old) != 0){
     perror("tcgetattr");
     return EXIT_FAILURE;
   }
@@ -131,7 +132,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if(old_action.sa_handler != SIG_IGN){
+  if (old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -143,7 +144,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if(old_action.sa_handler != SIG_IGN){
+  if (old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -155,7 +156,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if(old_action.sa_handler != SIG_IGN){
+  if (old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -164,22 +165,22 @@
   }
   
   
-  if(debug){
+  if (debug){
     fprintf(stderr, "Removing echo flag from terminal attributes\n");
   }
   
   t_new = t_old;
   t_new.c_lflag &= ~ECHO;
-  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
+  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     perror("tcsetattr-echo");
     return EXIT_FAILURE;
   }
 
-  if(debug){
+  if (debug){
     fprintf(stderr, "Waiting for input from stdin \n");
   }
   while(true){
-    if(quit_now){
+    if (quit_now){
       if(debug){
 	fprintf(stderr, "Interrupted by signal, exiting.\n");
       }
@@ -211,7 +212,7 @@
       }
     }
     ret = getline(&buffer, &n, stdin);
-    if(ret > 0){
+    if (ret > 0){
       status = EXIT_SUCCESS;
       /* Make n = data size instead of allocated buffer size */
       n = (size_t)ret;
@@ -232,8 +233,8 @@
       }
       break;
     }
-    if(ret < 0){
-      if(errno != EINTR and not feof(stdin)){
+    if (ret < 0){
+      if (errno != EINTR and not feof(stdin)){
 	perror("getline");
 	status = EXIT_FAILURE;
 	break;
@@ -248,17 +249,17 @@
       fprintf(stderr, "getline() returned 0, retrying.\n");
     }
   }
-  
+
   free(buffer);
   
-  if(debug){
+  if (debug){
     fprintf(stderr, "Restoring terminal attributes\n");
   }
-  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
+  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
     perror("tcsetattr+echo");
   }
   
-  if(debug){
+  if (debug){
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);
   }

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/password-prompt.xml	2008-10-04 01:55:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2009-01-14 14:20:17 +0000
+++ plugins.d/splashy.c	2008-10-03 09:32:30 +0000
@@ -1,28 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Splashy - Read a password from splashy and output it
- * 
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
@@ -30,13 +5,12 @@
 				   SIG_IGN, kill(), SIGKILL */
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf(), perror(), sscanf() */
-#include <stdlib.h>		/* EXIT_FAILURE, free(),
+#include <stdio.h>		/* asprintf(), perror() */
+#include <stdlib.h>		/* EXIT_FAILURE, free(), strtoul(),
 				   EXIT_SUCCESS */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
 				   ssize_t */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <inttypes.h>		/* intmax_t, SCNdMAX */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 #include <iso646.h>		/* not, or, and */
 #include <unistd.h>		/* readlink(), fork(), execl(),
@@ -98,18 +72,10 @@
     for(struct dirent *proc_ent = readdir(proc_dir);
 	proc_ent != NULL;
 	proc_ent = readdir(proc_dir)){
-      pid_t pid;
-      {
-	intmax_t tmpmax;
-	int numchars;
-	ret = sscanf(proc_ent->d_name, "%" SCNdMAX "%n", &tmpmax,
-		     &numchars);
-	if(ret < 1 or tmpmax != (pid_t)tmpmax
-	   or proc_ent->d_name[numchars] != '\0'){
-	  /* Not a process */
-	  continue;
-	}
-	pid = (pid_t)tmpmax;
+      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
+      if(pid == 0){
+	/* Not a process */
+	continue;
       }
       /* Find the executable name by doing readlink() on the
 	 /proc/<pid>/exe link */
@@ -129,10 +95,6 @@
 	struct stat exe_stat;
 	ret = lstat(exe_link, &exe_stat);
 	if(ret == -1){
-	  if(errno == ENOENT){
-	    free(exe_link);
-	    continue;
-	  }
 	  perror("lstat");
 	  free(exe_link);
 	  free(prompt);
@@ -276,7 +238,7 @@
     /* Child; will become new splashy process */
     
     /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (_mandos) */
+       the real user ID (mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
       perror("setuid");

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/splashy.xml	2008-10-04 03:11:39 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2009-01-14 14:20:17 +0000
+++ plugins.d/usplash.c	2008-10-03 09:32:30 +0000
@@ -1,28 +1,3 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Usplash - Read a password from usplash and output it
- * 
- * Copyright © 2008,2009 Teddy Hogeborn
- * Copyright © 2008,2009 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
 #define _GNU_SOURCE		/* asprintf() */
 #include <signal.h>		/* sig_atomic_t, struct sigaction,
 				   sigemptyset(), sigaddset(), SIGINT,
@@ -36,17 +11,17 @@
 				   dirent */
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strlen(), memcmp() */
-#include <stdio.h>		/* asprintf(), perror(), sscanf() */
+#include <stdio.h>		/* asprintf(), perror() */
 #include <unistd.h>		/* close(), write(), readlink(),
 				   read(), STDOUT_FILENO, sleep(),
 				   fork(), setuid(), geteuid(),
 				   setsid(), chdir(), dup2(),
 				   STDERR_FILENO, execv() */
-#include <stdlib.h>		/* free(), EXIT_FAILURE, realloc(),
-				   EXIT_SUCCESS, malloc(), _exit() */
+#include <stdlib.h>		/* free(), EXIT_FAILURE, strtoul(),
+				   realloc(), EXIT_SUCCESS, malloc(),
+				   _exit() */
 #include <stdlib.h>		/* getenv() */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <inttypes.h>		/* intmax_t, SCNdMAX */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 
 sig_atomic_t interrupted_by_signal = 0;
@@ -92,11 +67,10 @@
   }
   
   size_t written = 0;
-  ssize_t sret = 0;
   while(not interrupted_by_signal and written < cmd_line_len){
-    sret = write(fifo_fd, cmd_line + written,
-		 cmd_line_len - written);
-    if(sret == -1){
+    ret = write(fifo_fd, cmd_line + written,
+		cmd_line_len - written);
+    if(ret == -1){
       if(errno != EINTR or interrupted_by_signal){
 	int e = errno;
 	close(fifo_fd);
@@ -107,7 +81,7 @@
 	continue;
       }
     }
-    written += (size_t)sret;
+    written += (size_t)ret;
   }
   free(cmd_line_alloc);
   do{
@@ -170,18 +144,10 @@
     for(struct dirent *proc_ent = readdir(proc_dir);
 	proc_ent != NULL;
 	proc_ent = readdir(proc_dir)){
-      pid_t pid;
-      {
-	intmax_t tmpmax;
-	int numchars;
-	ret = sscanf(proc_ent->d_name, "%" SCNdMAX "%n", &tmpmax,
-		     &numchars);
-	if(ret < 1 or tmpmax != (pid_t)tmpmax
-	   or proc_ent->d_name[numchars] != '\0'){
-	  /* Not a process */
-	  continue;
-	}
-	pid = (pid_t)tmpmax;
+      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
+      if(pid == 0){
+	/* Not a process */
+	continue;
       }
       /* Find the executable name by doing readlink() on the
 	 /proc/<pid>/exe link */
@@ -201,10 +167,6 @@
 	struct stat exe_stat;
 	ret = lstat(exe_link, &exe_stat);
 	if(ret == -1){
-	  if(errno == ENOENT){
-	    free(exe_link);
-	    continue;
-	  }
 	  perror("lstat");
 	  free(exe_link);
 	  free(prompt);
@@ -220,6 +182,9 @@
 	
 	sret = readlink(exe_link, exe_target, sizeof(exe_target));
 	free(exe_link);
+	if(sret == -1){
+	  continue;
+	}
       }
       if((sret == ((ssize_t)sizeof(exe_target)-1))
 	 and (memcmp(usplash_name, exe_target,
@@ -494,7 +459,7 @@
     /* Child; will become new usplash process */
     
     /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (_mandos) */
+       the real user ID (mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
       perror("setuid");

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/usplash.xml	2008-10-04 03:11:39 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2008-10-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,7 +32,6 @@
     </authorgroup>
     <copyright>
       <year>2008</year>
-      <year>2009</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

